#!/usr/bin/perl -w
use Tk;
use Tk::Pane;
use Tk::JPEG;
use Tk::PNG;
use Tk::BrowseEntry;
use Tk::StayOnTop;
use File::Copy;
use GD;
use Cwd;
use Config;
use Iterator::Array::Jagged;
$|=1;

settings_1();
settings_2();
settings_3();
$cwd=getcwd;
$programfiles=$cwd."/easyPAC_files";
$MAIN_WINDOW=MainWindow->new(-title=>"easyPAC - PCR-primer prediction from alignments and consensus sequences",-background=>White);
$MAIN_WINDOW->geometry("1014x786");
$MAIN_WINDOW->protocol('WM_DELETE_WINDOW',sub{delete_temporary_files();exit;});
$mw=$MAIN_WINDOW->Scrolled('Pane',-scrollbars=>'osoe',-background=>White,-sticky=>'n',-gridded=>'y')->pack(-fill=>'both',-expand=>1);
$background=$mw->Photo(-format=>'png',-file=>"$programfiles/gui");
$mw->Label(-image=>$background,-background=>White)->pack();

###   INPUT AND PCR CONDITIONS   ###
$input_paste=$mw->Scrolled('Text',-font=>'Courier 8',-scrollbars=>'osoe',-relief=>'flat')->place(-height=>310,-width=>330,-x=>20,-y=>53);
$reset_input_button=$mw->Button(-text=>"reset input",-command=>sub{$input_paste->delete("1.0",'end');})->place(-width=>100,-height=>20,-y=>373,-x=>60);
$use_demo_button=$mw->Button(-text=>"use demo",-command=>\&use_demo)->place(-width=>100,-height=>20,-y=>373,-x=>210);
$filetypes=[['FASTA files', '.fas'],['All Files',   '*'],];
$input_file=$mw->Entry(-font=>"Arial 8",-width=>38,-textvariable=>\$alignment_file_name)->place(-height=>18,-x=>367,-y=>53);
$browse_input_button=$mw->Button(-font=>"Arial 8",-text=>"browse",-command=>sub{$alignment_file_name=$mw->getOpenFile(-filetypes=>$filetypes,-defaultextension=>'.fas');$input_file->configure(-textvariable=>$alignment_file_name);})->place(-width=>50,-height=>18,-x=>614,-y=>52);
$mw->Entry(-font=>"Arial 8",-width=>3,-textvariable=>\$ignore_gaps_in_alignment,-justify=>'right')->place(-height=>16,-x=>589,-y=>79);
$mw->Entry(-font=>"Arial 8",-width=>11,-textvariable=>\$PCR_target_start,-justify=>'right')->place(-height=>16,-x=>589,-y=>124);
$mw->Entry(-font=>"Arial 8",-width=>11,-textvariable=>\$PCR_target_end,-justify=>'right')->place(-height=>16,-x=>589,-y=>145);
$mw->Entry(-font=>"Arial 8",-width=>11,-textvariable=>\$excluded_regions_string)->place(-height=>16,-x=>589,-y=>166);
$mw->Entry(-font=>"Arial 8",-width=>11,-textvariable=>\$maximum_product_size,-justify=>'right')->place(-height=>16,-x=>589,-y=>188);
$mw->Entry(-font=>"Arial 8",-width=>48,-textvariable=>\$given_forward_primer)->place(-height=>18,-x=>367,-y=>226);
$mw->Entry(-font=>"Arial 8",-width=>48,-textvariable=>\$given_reverse_primer)->place(-height=>18,-x=>367,-y=>270);
$mw->Entry(-font=>"Arial 8",-width=>11,-textvariable=>\$primer_concentration,-justify=>'right')->place(-height=>16,-x=>589,-y=>318);
$mw->Entry(-font=>"Arial 8",-width=>11,-textvariable=>\$Na_concentration,-justify=>'right')->place(-height=>16,-x=>589,-y=>340);
$mw->Entry(-font=>"Arial 8",-width=>11,-textvariable=>\$Mg_concentration,-justify=>'right')->place(-height=>16,-x=>589,-y=>361);
$select_method_of_Tm_calculation=$mw->BrowseEntry(-font=>"Arial 8",-variable=>\$method_of_Tm_calculation,-width=>18,-listwidth=>38,-listheight=>2,-state=>'readonly')->place(-height=>16,-x=>531,-y=>382);
$select_method_of_Tm_calculation->insert('end',"basic","base stacking");

###   PRIMER SETTINGS   ###
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$minimum_primer_length,-justify=>'right')->place(-height=>16,-x=>859,-y=>37);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$maximum_primer_length,-justify=>'right')->place(-height=>16,-x=>859,-y=>58);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$optimum_primer_length,-justify=>'right')->place(-height=>16,-x=>859,-y=>79);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$minimum_Tm,-justify=>'right')->place(-height=>16,-x=>859,-y=>124);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$maximum_Tm,-justify=>'right')->place(-height=>16,-x=>859,-y=>145);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$optimum_Tm,-justify=>'right')->place(-height=>16,-x=>859,-y=>166);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$maximum_delta_Tm,-justify=>'right')->place(-height=>16,-x=>859,-y=>187);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$maximum_GC,-justify=>'right')->place(-height=>16,-x=>859,-y=>232);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$minimum_GC,-justify=>'right')->place(-height=>16,-x=>859,-y=>253);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$maximum_ambiguity_factor,-justify=>'right')->place(-height=>16,-x=>859,-y=>275);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$maximum_3'_complementarity,-justify=>'right')->place(-height=>16,-x=>859,-y=>296);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$maximum_3'_stability,-justify=>'right')->place(-height=>16,-x=>859,-y=>318);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$primer_3'_end_original,-justify=>'right')->place(-height=>16,-x=>859,-y=>339);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$maximum_poly_X,-justify=>'right')->place(-height=>16,-x=>859,-y=>360);
$mw->Entry(-font=>"Arial 8",-width=>5,-textvariable=>\$maximum_poly_XY,-justify=>'right')->place(-height=>16,-x=>859,-y=>382);

###   REFERENCE AND PROGRAM PERFORMANCE   ###
$references_listbox=$mw->Listbox(-font=>"Arial 8",-selectmode=>"extended")->place(-width=>310,-height=>80,-x=>922,-y=>51);
$scrolly=$mw->Scrollbar(-command=>['yview'=>$references_listbox],-takefocus=>1)->place(-height=>97,-x=>1232,-y=>51);
$scrollx=$mw->Scrollbar(-orient=>'horizontal',-command=>['xview'=>$references_listbox],-takefocus=>1)->place(-width=>310,-x=>922,-y=>131);
$references_listbox->configure(-yscrollcommand=>['set',$scrolly],-xscrollcommand=>['set',$scrollx]);
$browse_and_add_button=$mw->Button(-font=>"Arial 8",-text=>"browse & add",-command=>sub{$reference=$mw->getOpenFile(-filetypes=>$filetypes,-defaultextension=>'.fas');if($reference){$references_listbox->insert('end',$reference);}})->place(-width=>90,-height=>18,-x=>993,-y=>152);
$remove_from_list_button=$mw->Button(-font=>"Arial 8",-text=>"remove from list",-command=>sub{@list=$references_listbox->curselection;@list=reverse@list;foreach(@list){$references_listbox->delete($_);}})->place(-width=>90,-height=>18,-x=>1093,-y=>152);
$mw->Checkbutton(-variable=>\$allow_one_match_in_reference)->place(-width=>15,-height=>13,-x=>1173,-y=>176);
$mw->Checkbutton(-variable=>\$do_sequence_annotation)->place(-width=>15,-height=>13,-x=>1173,-y=>197);
$remove_poly_N=$mw->Entry(-font=>"Arial 8",-width=>9,-textvariable=>\$remove_poly_N_from_reference,-justify=>'right',-state=>'disabled')->place(-height=>16,-x=>1173,-y=>217);
$select_perl_or_seqmap=$mw->BrowseEntry(-font=>"Arial 8",-variable=>\$perl_or_seqmap,-width=>9,-listwidth=>20,-listheight=>2,-state=>'readonly',-command=>\&check_seqmap)->place(-height=>16,-x=>1173,-y=>239);
$select_perl_or_seqmap->insert('end',"SeqMap","easyPAC");
$mm_seqmap=$mw->BrowseEntry(-justify=>'right',-font=>"Arial 8",-variable=>\$mismatch_seqmap,-width=>9,-listwidth=>20,-listheight=>6,-state=>'readonly')->place(-height=>16,-x=>1173,-y=>261);
$mm_seqmap->insert('end',"0","1","2","3","4","5");
$insdel__seqmap=$mw->BrowseEntry(-justify=>'right',-font=>"Arial 8",-variable=>\$insdel_seqmap,-width=>9,-listwidth=>20,-listheight=>4,-state=>'readonly')->place(-height=>16,-x=>1173,-y=>282);
$insdel__seqmap->insert('end',"0","1","2","3");
$mm_perl=$mw->BrowseEntry(-justify=>'right',-font=>"Arial 8",-variable=>\$mismatch_perl,-width=>9,-listwidth=>20,-listheight=>2,-state=>'readonly')->place(-height=>16,-x=>1173,-y=>304);
$mm_perl->insert('end',"0","1");
$mw->Entry(-font=>"Arial 8",-width=>9,-textvariable=>\$primer_pairs_in_graphical_output,-justify=>'right')->place(-height=>16,-x=>1173,-y=>341);
$mw->Entry(-font=>"Arial 8",-width=>9,-textvariable=>\$minimum_primer_pair_output,-justify=>'right')->place(-height=>16,-x=>1173,-y=>362);
$mw->Entry(-font=>"Arial 8",-width=>9,-textvariable=>\$best_left_right,-justify=>'right')->place(-height=>16,-x=>1173,-y=>383);

###   RESULTS   ###
$results_master_frame=$mw->Frame(-background=>"grey98")->place(-width=>745,-height=>443,-x=>359,-y=>462);
sub display_text
	{
	$results_master_frame->destroy;
	$results_master_frame=$mw->Frame(-background=>"grey98")->place(-width=>745,-height=>443,-x=>359,-y=>462);
	
	$results_text_button->configure(-state=>'disabled');
	$results_picture_button->configure(-state=>'normal');
	$results_textwidget=$results_master_frame->Scrolled('Text',-font=>'Courier 8',-wrap=>'none',-scrollbars=>'se',-relief=>'flat')->pack(-fill=>'both',-expand=>1);
	$results_textwidget->insert("1.0",$results_text);
	}
sub display_picture
	{
	$results_master_frame->destroy;
	$results_master_frame=$mw->Frame(-background=>"grey98")->place(-width=>745,-height=>443,-x=>359,-y=>462);
	
	$results_text_button->configure(-state=>'normal');
	$results_picture_button->configure(-state=>'disabled');
	$results_pane=$results_master_frame->Scrolled('Pane',-scrollbars =>'osoe',-background=>"grey98")->pack(-fill=>'both',-expand=>1);
	$results_pane->Label(-image=>$results_image)->pack(-fill=>'both',-expand=>1);
	}

###   BUTTONS   ###
$reset_button=$mw->Button(-text=>"reset easyPAC",-activebackground=>"khaki1",-background=>"khaki1",-command=>sub{$results_picture_button->configure(-state=>'disabled');$results_text_button->configure(-state=>'disabled');$input_sequence="";$alignment_file_name="";$input_file->destroy;$input_file=$mw->Entry(-font=>"Arial 8",-width=>38,-textvariable=>\$alignment_file_name)->place(-height=>18,-x=>367,-y=>53);;clean_arrays();$results_master_frame->destroy;$results_master_frame=$mw->Frame(-background=>"grey98")->place(-width=>745,-height=>443,-x=>359,-y=>462);settings_1();settings_2();settings_3();$input_paste->delete("1.0",'end');})->place(-width=>150,-height=>30,-y=>459,-x=>1113);
$manual_button=$mw->Button(-text=>"easyPAC manual",-activebackground=>"slategray1",-background=>"slategray1",-command=>\&info)->place(-width=>150,-height=>30,-y=>509,-x=>1113);
$pick_button=$mw->Button(-text=>"pick primers",-activebackground=>"darkseagreen1",-background=>"darkseagreen1",-command=>\&check_settings)->place(-width=>150,-height=>30,-y=>559,-x=>1113);
$results_text_button=$mw->Button(-text=>"show results (text)",-command=>\&display_text,-state=>'disabled')->place(-width=>150,-height=>30,-y=>609,-x=>1113);
$results_picture_button=$mw->Button(-text=>"show results (picture)",-command=>\&display_picture,-state=>'disabled')->place(-width=>150,-height=>30,-y=>659,-x=>1113);
$save_results_button=$mw->Button(-text=>"save results",-command=>\&save_results,-state=>'disabled')->place(-width=>150,-height=>30,-y=>709,-x=>1113);
$exit_button=$mw->Button(-text=>"exit",-activebackground=>"salmon",-background=>"salmon",-command=>sub{delete_temporary_files();exit;})->place(-width=>150,-height=>30,-y=>759,-x=>1113);

@buttons=($browse_input_button,$reset_input_button,$use_demo_button,$browse_and_add_button,$remove_from_list_button,$reset_button,$manual_button,$pick_button,$results_text_button,$results_picture_button,$save_results_button,$exit_button);

###   PREPARE CORRECT SEQMAP VERSION   ###
if($Config{archname}=~/win/i)
	{
	if($Config{archname}=~/x64/i)
		{
		unless(copy("easyPAC_files/SeqMap/Windows_64/seqmap","seqmap"))
			{$mw->messageBox(-message=>"Could not add seqmap file to current working directory.\nTry copying the appropriate file manually from the \"easyPAC/SeqMap/Windows_64\" folder and click OK.",-type=>'ok',-icon=>'error');}
		}
	else
		{
		unless(copy("easyPAC_files/SeqMap/Windows_32/seqmap","seqmap"))
			{$mw->messageBox(-message=>"Could not add seqmap file to current working directory.\nTry copying the appropriate file manually from the \"easyPAC/SeqMap/Windows_32\" folder and click OK.",-type=>'ok',-icon=>'error');}
		}
	}
elsif($Config{archname}=~/linux/i)
	{
	if($Config{archname}=~/x64/i)
		{
		unless(copy("easyPAC_files/SeqMap/Linux_64/seqmap","seqmap"))
			{$mw->messageBox(-message=>"Could not add seqmap file to current working directory.\nTry copying the appropriate file manually from the \"easyPAC/SeqMap/Linux_64\" folder and click OK.",-type=>'ok',-icon=>'error');}
		}
	else
		{
		unless(copy("easyPAC_files/SeqMap/Linux_32/seqmap","seqmap"))
			{$mw->messageBox(-message=>"Could not add seqmap file to current working directory.\nTry copying the appropriate file manually from the \"easyPAC/SeqMap/Linux_32\" folder and click OK.",-type=>'ok',-icon=>'error');}
		}
	
	}
elsif($Config{archname}=~/darwin/i)
	{
	if($Config{archname}=~/x64/i)
		{
		unless(copy("easyPAC_files/SeqMap/MacOS_64/seqmap","seqmap"))
			{$mw->messageBox(-message=>"Could not add seqmap file to current working directory.\nTry copying the appropriate file manually from the \"easyPAC/SeqMap/MacOS_64\" folder and click OK.",-type=>'ok',-icon=>'error');}
		}
	else
		{
		unless(copy("easyPAC_files/SeqMap/MacOS_32/seqmap","seqmap"))
			{$mw->messageBox(-message=>"Could not add seqmap file to current working directory.\nTry copying the appropriate file manually from the \"easyPAC/SeqMap/MacOS_32\" folder and click OK.",-type=>'ok',-icon=>'error');}
		}
	}
else
	{
	$mw->messageBox(-message=>"Error! Could not determine adequate SeqMap file for your operating system ($Config{archname}).\nPrimer search in reference file(s) will be performed with easyPAC.",-type=>'ok',-icon=>'info');
	$perl_or_seqmap="easyPAC";
	}

###   MANUAL   ###
$info=$mw->Photo(-format=>'png',-file=>"easyPAC_files/man");
$info_toplevel_status=0;
sub info
	{
	if($info_toplevel_status==0)
		{
		$info_toplevel_status=1;
		$info_toplevel=$mw->Toplevel(-background=>"White");
		$info_toplevel->title("easyPAC manual");
		$info_toplevel->geometry("660x800");
		$info_toplevel->protocol('WM_DELETE_WINDOW',sub{$info_toplevel->destroy;$info_toplevel_status=0;});
		$info_pane=$info_toplevel->Scrolled('Pane',-scrollbars=>'osoe',-background=>White,-sticky=>'nw',-gridded=>'y')->pack(-fill=>'both',-expand=>1);		
		$info_pane->Label(-image=>$info,-background=>White)->pack();
		$info_pane->Button(-text=>" close ",-command=>sub{$info_toplevel->destroy;$info_toplevel_status=0;})->pack();
		$info_pane->Label(-background=>White,-text=>"\n\n\n")->pack();
		}
	}

#######
MainLoop;

sub settings_1
	{
	$alignment_file_name="";
	$ignore_gaps_in_alignment=0;
	$PCR_target_start="";
	$PCR_target_end="";
	$excluded_regions_string="";
	$maximum_product_size=1000;
	$given_forward_primer="";
	$given_reverse_primer="";
	$primer_concentration=50;
	$Na_concentration=0.05;
	$Mg_concentration=0;
	$method_of_Tm_calculation="base stacking";
	}
sub settings_2
	{
	$minimum_primer_length=18;
	$maximum_primer_length=28;
	$optimum_primer_length=20;
	$minimum_Tm=52;
	$maximum_Tm=65;
	$optimum_Tm=58;
	$maximum_delta_Tm=6;
	$maximum_GC=80;
	$minimum_GC=20;
	$maximum_ambiguity_factor=16;
	$maximum_3'_complementarity=3;
	$maximum_3'_stability=6;
	$primer_3'_end_original="N";
	$maximum_poly_X=4;
	$maximum_poly_XY=3;
	}
sub settings_3
	{
	@reference_files=();
	$allow_one_match_in_reference=0;
	$do_sequence_annotation=1;
	$remove_poly_N_from_reference=6;
	$perl_or_seqmap="SeqMap";
	$mismatch_seqmap=2;
	$insdel_seqmap=1;
	$mismatch_perl=0;
	$primer_pairs_in_graphical_output=20;
	$minimum_primer_pair_output=100;
	$best_left_right=25;
	}
sub check_seqmap
	{
	if($perl_or_seqmap eq"easyPAC")
		{
		$remove_poly_N->configure(-state=>'normal');
		}
	else
		{
		$remove_poly_N->configure(-state=>'disabled');
		unless(open(TEST_SEQMAP_PRESENCE,"seqmap"))
			{
			$mw->messageBox(-message=>"Could not find seqmap in working folder!\nThis will slow down primer search in reference file(s).\nSeqMap is freely available at\nhttp://www-personal.umich.edu/~jianghui/seqmap/",-type=>'ok',-icon=>'error');
			$perl_or_seqmap="easyPAC";
			}
		else
			{
			close TEST_SEQMAP_PRESENCE;
			}
		}
	}
sub check_settings
	{
	$error_index=0;
	$error_message="";
	check_seqmap();
	$input_sequence=$input_paste->get("1.0",'end');
	if($input_sequence=~/^\s*$/)
		{
		$input_sequence="";
		}
	unless(length$input_sequence>0)
		{
		unless(open(TEST,"$alignment_file_name"))
			{$error_index=1;$error_message.="No sequence pasted.\nCould not open file:\n$alignment_file_name\n\n";}
		else
			{close TEST;}
		unless($PCR_target_start=~/^\d+$/||$PCR_target_end=~/^\d+$/)
			{
			$error_index=1;$error_message.="PCR target choordinates must be numerical!\n";
			}
		if($PCR_target_start&&$PCR_target_end)
			{
			unless($PCR_target_start<$PCR_target_end)
				{$error_index=1;$error_message.="PCR target start choordinate must be < end choordinate!\n";}
			unless($maximum_product_size>($PCR_target_end-$PCR_target_start))
				{$error_index=1;$error_message.="Maximum product size must be > target!\n";}
			}
		$excluded_regions_string=~s/ //g;
		@excluded_regions=split(';',$excluded_regions_string);
		foreach(@excluded_regions)
			{
			unless($_=~/^\d+-\d+$/)
				{$error_index=1;$error_message.="Excluded region quoted in wrong format!\n";}
			}
		}
	unless($maximum_product_size=~/^\d+$/)
		{$error_index=1;$error_message.="Maximum product size must be numerical!\n";}
	unless($given_forward_primer=~/^[ATGCRYSWKMBDHVN]*$/i)
		{$error_index=1;$error_message.="Forward primer contains non-IUPAC symbols!\n";}
	unless($given_reverse_primer=~/^[ATGCRYSWKMBDHVN]*$/i)
		{$error_index=1;$error_message.="Reverse primer contains non-IUPAC symbols!\n";}
	unless($primer_concentration=~/^\d?\.?\d+$/)
		{$error_index=1;$error_message.="Primer concentration must be numerical!\n";}
	unless($Na_concentration=~/^\d?\.?\d+$/)
		{$error_index=1;$error_message.="Na+ concentration must be numerical!\n";}
	unless($Mg_concentration=~/^\d?\.?\d+$/)
		{$error_index=1;$error_message.="Mg2+ concentration must be numerical!\n";}
	unless($minimum_primer_length=~/^\d+$/)
		{$error_index=1;$error_message.="Minimum primer length must be numerical!\n";}
	unless($maximum_primer_length=~/^\d+$/)
		{$error_index=1;$error_message.="Maximum primer length must be numerical!\n";}
	unless($optimum_primer_length=~/^\d+$/)
		{$error_index=1;$error_message.="Optimum primer length must be numerical!\n";}
	unless($minimum_primer_length<=$maximum_primer_length)
		{$error_index=1;$error_message.="Minimum primer length must be < maximum primer length!\n";}
	unless($optimum_primer_length>=$minimum_primer_length||$optimum_primer_length<=$maximum_primer_length)
		{$error_index=1;$error_message.="Optimum primer length outside stated length range!\n";}
	unless($minimum_Tm=~/^\d?\.?\d+$/)
		{$error_index=1;$error_message.="Minimum Tm must be numerical!\n";}
	unless($maximum_Tm=~/^\d?\.?\d+$/)
		{$error_index=1;$error_message.="Maximum Tm must be numerical!\n";}
	unless($optimum_Tm=~/^\d?\.?\d+$/)
		{$error_index=1;$error_message.="Optimum Tm must be numerical!\n";}
	unless($minimum_Tm<=$maximum_Tm)
		{$error_index=1;$error_message.="Minimum Tm must be < maximum Tm!\n";}
	unless($optimum_Tm>=$minimum_Tm||$optimum_Tm<=$maximum_Tm)
		{$error_index=1;$error_message.="Optimum Tm outside stated Tm range!\n";}
	unless($maximum_delta_Tm=~/^\d?\.?\d+$/)
		{$error_index=1;$error_message.="Maximum delta Tm must be numerical!\n";}
	unless($maximum_GC=~/^\d+$/||$maximum_GC>100)
		{$error_index=1;$error_message.="Maximum GC[%] must be numerical <= 100!\n";}
	unless($minimum_GC=~/^\d+$/||$minimum_GC>100)
		{$error_index=1;$error_message.="Minimum GC[%] must be numerical <= 100!\n";}
	unless($minimum_GC<=$maximum_GC)
		{$error_index=1;$error_message.="Minimum GC[%] must be >= Maximum GC[%]!\n";}
	unless($maximum_ambiguity_factor=~/^\d+$/)
		{$error_index=1;$error_message.="Maximum degeneracy must be numerical >= 1!\n";}
	unless($maximum_3'_complementarity=~/^\d+$/)
		{$error_index=1;$error_message.="Maximum 3'-complementarity must be numerical!\n";}
	unless($maximum_3'_stability=~/^\d?\.?\d+$/)
		{$error_index=1;$error_message.="Maximum 3'-stability must be numerical!\n";}
	unless($primer_3'_end_original=~/^[ATGCRYSWKMBDHVN]+$/i)
		{$error_index=1;$error_message.="Stated primer 3'-end contains non-IUPAC symbols!\n";}
	unless($maximum_poly_X=~/^\d+$/)
		{$error_index=1;$error_message.="Maximum poly-X must be numerical!\n";}
	unless($maximum_poly_XY=~/^\d+$/)
		{$error_index=1;$error_message.="Maximum poly-XY must be numerical!\n";}
	unless($remove_poly_N_from_reference=~/^\d+$/)
		{$error_index=1;$error_message.="poly-N to be removed from reference must be numerical!\n";}
	unless($primer_pairs_in_graphical_output=~/^\d+$/)
		{$error_index=1;$error_message.="Primer pairs in graphical output must be numerical!\n";}
	unless($minimum_primer_pair_output=~/^\d+$/)
		{$error_index=1;$error_message.="Minimum primer pair output must be numerical!\n";}
	unless($best_left_right=~/^\d+$/)
		{$error_index=1;$error_message.="Take best n for./rev. primer must be numerical!\n";}
	if($error_index==0)
		{start();}
	else
		{$mw->messageBox(-message=>"Error in settings:\n$error_message",-type=>'ok',-icon=>'error');}
	}
sub start
	{
	###   NEW TOPLEVEL   ###
	foreach(@buttons)
		{
		$_->configure(-state=>'disabled');
		}
	$results_master_frame->destroy;
	$results_master_frame=$mw->Frame(-background=>"grey98")->place(-width=>745,-height=>443,-x=>359,-y=>462);
	$results_text="";
	$results_image="";
	$computation_start=time;
	$start_smartprime=$mw->Toplevel(-background=>White,-title=>"Primer search started...");
	$start_smartprime->geometry("620x500");
	$start_smartprime->protocol('WM_DELETE_WINDOW',sub{close_progress_window();});
	$progress_pane=$start_smartprime->Scrolled('Pane',-scrollbars=>'osoe',-background=>White,-sticky=>'nw',-gridded=>'y')->pack(-fill=>'both',-expand=>1);
	$progress_text=" Primer search started...\n\n";
	$progress_label=$progress_pane->Label(-font=>"Courier 8",-justify=>'left',-background=>White,-text=>"$progress_text",-cursor=>'watch')->pack(-side=>'left',-fill=>'x');
	$start_smartprime->stayOnTop();
	$start_smartprime->update;
	sleep(1);
	@reference_files=$references_listbox->get(0,'end');
	if(@reference_files>1)
		{
		$reference_file_name="merged_references";
		open (MERGE,">>$reference_file_name");
		foreach $file(@reference_files)
			{
			open(FILE,"$file");
			while(<FILE>)
				{
				print MERGE$_;
				}
			close FILE;
			}
		close MERGE;
		}
	elsif(@reference_files==1)
		{
		$reference_file_name=$reference_files[0];
		}
	$primer_3'_end=$primer_3'_end_original;
	
	###   READ INPUT FROM TEXT FIELD   ###
	@sequences=();
	unless($input_sequence=~/^\s*$/)
		{
		unless($input_sequence=~/>/)
			{
			$input_sequence=">sequence1\n".$input_sequence;
			}
		}
	if(length$input_sequence>0&&$input_sequence!~/^\s*$/)
		{
		$alignment_file_name=" n.a. / input from text field";
		@input_sequence=split('',$input_sequence);
		$progress_text.="\n Read input from text field... ";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		$status=0;
		$title="";
		$sequence="";
		$error_status=0;
		$unrecognized_characters="";
		$seq_pos=0;
		foreach$character(@input_sequence)
			{
			if($character eq ">")
				{
				if($status==2)
					{
					push(@sequences,$sequence);
					$sequence="";
					}
				$status=1;
				}
			elsif($character eq "\n")
				{
				if($status==1)
					{
					push(@titles,$title);
					$title="";
					$seq_pos=0;
					}
				unless(@titles==0)
					{
					$status=2;
					}
				}
			if($status==1)
				{
				$title=$title.$character;
				}
			elsif ($status==2)
				{
				if($character=~/[ATGCRYSWKMBDHVN-]/i)
					{
					$seq_pos++;
					$sequence=$sequence.$character;
					}
				elsif($character=~/\[/)
					{
					$PCR_target_start=$seq_pos+1;
					}
				elsif($character=~/\]/)
					{
					$PCR_target_end=$seq_pos;
					}
				elsif($character=~/\{/)
					{
					$ex_seq_pos=$seq_pos+1;
					$excluded_regions_string.="$ex_seq_pos-";
					}
				elsif($character=~/\}/)
					{
					$excluded_regions_string.="$seq_pos; ";
					}
				elsif($character=~/\./)
					{
					$character="-";
					$sequence=$sequence.$character;
					}
				else
					{
					unless ($character=~/\n/)
						{
						$unrecognized_characters=$unrecognized_characters."$character";
						$character="N";
						$sequence=$sequence.$character;
						$error_status=1;
						}
					}
				}
			}
		push(@sequences,$sequence);
		$excluded_regions_string=~s/ //g;
		$excluded_regions_string=~s/; $//;
		@excluded_regions=split(';',$excluded_regions_string);
		}
	else
		{
		###   READ ALIGNMENT-FILE   ###
		$progress_text.="\n Read input from file... ";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		open(INPUT_ALIGNMENT,"$alignment_file_name");
		$status=0;
		$title="";
		$sequence="";
		$error_status=0;
		$unrecognized_characters="";
		while(read(INPUT_ALIGNMENT,$character,1))
			{
			if($character eq ">")
				{
				if($status==2)
					{
					push(@sequences,$sequence);
					$sequence="";
					}
				$status=1;
				}
			elsif($character eq "\n")
				{
				if($status==1)
					{
					push(@titles,$title);
					$title="";
					}
				unless(@titles==0)
					{
					$status=2;
					}
				}
			if($status==1)
				{
				$title=$title.$character;
				}
			elsif ($status==2)
				{
				if($character=~/[ATGCRYSWKMBDHVN-]/i)
					{
					$sequence=$sequence.$character;
					}
				elsif($character=~/\./)
					{
					$character="-";
					$sequence=$sequence.$character;
					}
				else
					{
					unless ($character=~/\n/)
						{
						$unrecognized_characters=$unrecognized_characters."$character";
						$character="N";
						$sequence=$sequence.$character;
						$error_status=1;
						}
					}
				}
			}
		push(@sequences,$sequence);
		close INPUT_ALIGNMENT;
		}

	###   CHECK LENGH IDENTITY IN ALIGNMENT-FILE   ###
	$number_of_sequences=@sequences;
	$length=length$sequences[0];
	foreach(1..($number_of_sequences-1))
		{
		unless($length==length$sequences[$_])
			{
			$start_smartprime->messageBox(-message=>"Error in input file!\nSequences are not of equal length!",-type=>'ok',-icon=>'error');
			$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
			}
		}
	$progress_text.="done.\n Input contains $number_of_sequences sequence(s) each $length nt in length.\n\n";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	if($error_status==1)
		{
		$progress_text.=" Unknown characters ($unrecognized_characters) have been replaced by \"N\"!\n\n";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		}

	###   CHECK FOR POLY-N IN INPUT   ###
	$poly_N_index=0;
	foreach(@sequences)
		{
		if($_=~/NNNNNNNN/i)
			{
			$poly_N_index=1;
			}
		}
	if($poly_N_index==1)
		{
		$answer=$start_smartprime->messageBox(-title=>"Attention!",-message=>"At least one of your sequences contains stretches of N's. It is strongly recommended to replace them by '-'. Otherwise every part of the alignment may be assessed as internal duplication. Do you want easyPAC to replace them before continue?",-type=>'YesNo',-icon=>'question',-default=>'yes');
		if($answer=~/yes/i)
			{
			$did_a_replacement=1;
			while($did_a_replacement==1)
				{
				$did_a_replacement=0;
				foreach(@sequences)
					{
					if($_=~/NNNNNNNNN*/)
						{
						$replacing_string="";
						foreach(1..length$&)
							{
							$replacing_string.="-";
							}
						$_=~s/NNNNNNNNN*/$replacing_string/;
						$did_a_replacement=1;
						}
					}
				}
			}
		}

	###   READ REFERENCE FILE   ###
	if(@reference_files>0&&$perl_or_seqmap eq "easyPAC")
	{
	foreach$reference_file(@reference_files)
		{
		$progress_text.=" Read reference file... ";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		$reference_total_size=0;
		$status=0;
		$removed_poly_N=0;
		$sequence="";
		$title="";
		open(INPUT_REFERENCE,"$reference_file");
		while(read(INPUT_REFERENCE,$character,1))
			{
			if($character eq ">")
				{
				if ($status==2)
					{
					if($sequence=~s/N{$remove_poly_N_from_reference,}/-polyN-/gi)
						{
						$removed_poly_N=1;
						}
					push(@rep_sequences,$sequence);
					$sequence="";
					}
				$status=1;
				}
			elsif($character eq "\n")
				{
				if ($status==1)
					{
					push(@rep_titles,$title);
					$title="";
					}
				unless(@titles==0)
					{
					$status=2;
					}
				}
			if($status==1)
				{
				$title=$title.$character;
				}
			elsif ($status==2)
				{
				if($character=~/[ATGCRYSWKMBDHVN-]/i)
					{
					$reference_total_size++;
					$sequence=$sequence.$character;
					}
				elsif($character=~/\./)
					{
					$reference_total_size++;
					$character="-";
					$sequence=$sequence.$character;
					}
				}
			}
		if($sequence=~s/N{$remove_poly_N_from_reference,}/-polyN-/gi)
			{
			$removed_poly_N=1;
			}
		push(@rep_sequences,$sequence);
		close INPUT_REFERENCE;
		$progress_text.="done.\n";
		if($removed_poly_N==1)
			{
			$progress_text.="\n Removed poly-N from reference file!\n\n";
			}
		if($reference_total_size>100000)
			{
			$progress_text.=" $reference_file is a large file (merged sequence length = $reference_total_size nt).\n Comparing primer sequences with reference may take several minutes!\n";
			if($do_sequence_annotation==1)
				{
				$progress_text.=" Alignment annotation may take several minutes!\n\n";
				}
			else
				{
				$progress_text.="\n";
				}
			}
		else
			{
			$progress_text.="\n";
			}
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		}
	}

	###   LIST VARIANTS AT EACH POSITION, CREATE CONSENSUS STRING   ###
	$progress_text.=" create consensus sequence... ";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	$condition="";
	$variants="";
	$consensus="";
	foreach$position(0..($length-1))
		{
		foreach$seq_id(0..($number_of_sequences-1))
			{
			$letter=substr($sequences[$seq_id],$position,1);
			$condition=$condition.$letter;
			}
		push(@conditions,$condition);
		$condition="";
		}
	$index_A=0;
	$index_T=0;
	$index_G=0;
	$index_C=0;
	$index_N=0;
	$index_space=0;
	foreach$position(@conditions)
		{
		@positional_conditions=split('',$position);
		foreach$positional_condition(@positional_conditions)
			{
			if ($positional_condition=~/A/i){$index_A=1;}
			elsif ($positional_condition=~/T/i){$index_T=1;}
			elsif ($positional_condition=~/G/i){$index_G=1;}
			elsif ($positional_condition=~/C/i){$index_C=1;}
			elsif ($positional_condition=~/R/i){$index_G=1;$index_A=1;}
			elsif ($positional_condition=~/Y/i){$index_C=1;$index_T=1;}
			elsif ($positional_condition=~/S/i){$index_G=1;$index_C=1;}
			elsif ($positional_condition=~/W/i){$index_A=1;$index_T=1;}
			elsif ($positional_condition=~/K/i){$index_G=1;$index_T=1;}
			elsif ($positional_condition=~/M/i){$index_C=1;$index_A=1;}
			elsif ($positional_condition=~/B/i){$index_C=1;$index_G=1;$index_T=1;}
			elsif ($positional_condition=~/D/i){$index_A=1;$index_G=1;$index_T=1;}
			elsif ($positional_condition=~/H/i){$index_A=1;$index_C=1;$index_T=1;}
			elsif ($positional_condition=~/V/i){$index_A=1;$index_C=1;$index_G=1;}
			elsif ($positional_condition=~/N/i){$index_N=1;}
			elsif ($positional_condition=~/-/){$index_space++;}
			}
		######################### consensus ###############################
		if ($index_A==1 && $index_T==0 && $index_G==0 && $index_C==0 && $index_N==0)
			{$consensus=$consensus."A";}
		elsif ($index_A==0 && $index_T==1 && $index_G==0 && $index_C==0 && $index_N==0)
			{$consensus=$consensus."T";}
		elsif ($index_A==0 && $index_T==0 && $index_G==1 && $index_C==0 && $index_N==0)
			{$consensus=$consensus."G";}
		elsif ($index_A==0 && $index_T==0 && $index_G==0 && $index_C==1 && $index_N==0)
			{$consensus=$consensus."C";}
		elsif ($index_A==1 && $index_T==0 && $index_G==0 && $index_C==1 && $index_N==0)
			{$consensus=$consensus."M";}
		elsif ($index_A==1 && $index_T==0 && $index_G==1 && $index_C==0 && $index_N==0)
			{$consensus=$consensus."R";}
		elsif ($index_A==1 && $index_T==1 && $index_G==0 && $index_C==0 && $index_N==0)
			{$consensus=$consensus."W";}
		elsif ($index_A==0 && $index_T==0 && $index_G==1 && $index_C==1 && $index_N==0)
			{$consensus=$consensus."S";}
		elsif ($index_A==0 && $index_T==1 && $index_G==0 && $index_C==1 && $index_N==0)
			{$consensus=$consensus."Y";}
		elsif ($index_A==0 && $index_T==1 && $index_G==1 && $index_C==0 && $index_N==0)
			{$consensus=$consensus."K";}
		elsif ($index_A==1 && $index_T==0 && $index_G==1 && $index_C==1 && $index_N==0)
			{$consensus=$consensus."V";}
		elsif ($index_A==1 && $index_T==1 && $index_G==0 && $index_C==1 && $index_N==0)
			{$consensus=$consensus."H";}
		elsif ($index_A==1 && $index_T==1 && $index_G==1 && $index_C==0 && $index_N==0)
			{$consensus=$consensus."D";}
		elsif ($index_A==0 && $index_T==1 && $index_G==1 && $index_C==1 && $index_N==0)
			{$consensus=$consensus."B";}
		elsif ($index_A==1 && $index_T==1 && $index_G==1 && $index_C==1 && $index_N==0)
			{$consensus=$consensus."N";}
		elsif ($index_A==0 && $index_T==0 && $index_G==0 && $index_C==0 && $index_N==0)
			{$consensus=$consensus."-";}
		elsif ($index_N==1)
			{$consensus=$consensus."N";}
		###############################################################
		if ($index_N==1)
			{
			$number_of_variants=4;
			}
		elsif ($index_space>$ignore_gaps_in_alignment)
			{
			$number_of_variants=0;
			}
		else
			{
			$number_of_variants=$index_A+$index_T+$index_G+$index_C;
			}
		$variants=$variants.$number_of_variants;
		$index_A=0;
		$index_T=0;
		$index_G=0;
		$index_C=0;
		$index_N=0;
		$index_space=0;
		}
	$progress_text.="done.\n\n";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;

	###   SEQUENCE ANNOTATION   ###
	# 	0 = ok
	#	1 = PCR-target
	#	2 = excluded regions
	#	3 = out of range (max. product size)
	#	4 = simple repeats
	#	5 = internal duplication
	#	6 = internal duplication (rc)
	#	7 = reference match
	#	8 = reference match (rc)
	#	s = no reference match (SeqMap)
	#	S = reference match (SeqMap)
	
	$progress_text.=" Alignment annotation in progress... ";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	
	@sequence_annotation=();
	foreach(1..$length)
		{
		push(@sequence_annotation,"0");
		}
	foreach($PCR_target_start-1..$PCR_target_end-1)
		{
		$sequence_annotation[$_].="1";
		}
	foreach$excluded_region(@excluded_regions)
		{
		$start=$excluded_region;
		$end=$excluded_region;
		$start=~s/-\d+$//;
		$end=~s/^\d+-//;
		foreach($start-1..$end-1)
			{
			$sequence_annotation[$_].="2";
			}
		}
	if(($PCR_target_end-$maximum_product_size+$minimum_primer_length)>0)
		{
		foreach(0..($PCR_target_end-$maximum_product_size+$minimum_primer_length))
			{
			$sequence_annotation[$_].="3";
			}
		}
	if(($PCR_target_start+$maximum_product_size-$minimum_primer_length)<$length-1)
		{
		foreach(($PCR_target_start+$maximum_product_size-$minimum_primer_length)..$length-1)
			{
			$sequence_annotation[$_].="3";
			}
		}
	@poly_X=("[ARWMDHVN]","[TYWKBDHN]","[GRSKBDVN]","[CYSMBHVN]");
	foreach$poly_X(@poly_X)
		{
		$poly_X_search="";
		foreach(0..$maximum_poly_X)
			{
			$poly_X_search=$poly_X_search.$poly_X;
			}
		push(@poly_X_search,$poly_X_search);
		}
	@poly_X_combine=@poly_X;
	foreach$nucleotide(@poly_X)
		{	
		foreach$nucleotide2(@poly_X_combine)
			{
			push(@poly_XY,"$nucleotide$nucleotide2");
			}
		}
	foreach$poly_XY(@poly_XY)
		{
		$poly_XY_search="";
		foreach(0..$maximum_poly_XY)
			{
			$poly_XY_search=$poly_XY_search.$poly_XY;
			}
		push(@poly_XY_search,$poly_XY_search);
		}
	foreach$position(0..$length-$maximum_poly_X-1)
		{
		$check_substr=substr($consensus,$position,$maximum_poly_X+1);
		foreach$poly_X(@poly_X_search)
			{
			if($check_substr=~/$poly_X/i)
				{
				foreach($position..$position+$maximum_poly_X)
					{
					unless($sequence_annotation[$_]=~/4/)
						{
						$sequence_annotation[$_].="4";
						}
					}
				}
			}
		}
	foreach$position(0..$length-$maximum_poly_XY-1)
		{
		$check_substr=substr($consensus,$position,($maximum_poly_XY*2)+2);
		foreach$poly_XY(@poly_XY_search)
			{
			if($check_substr=~/$poly_XY/i)
				{
				foreach($position..$position+($maximum_poly_XY*2)+1)
					{
					unless($sequence_annotation[$_]=~/4/)
						{
						$sequence_annotation[$_].="4";
						}
					}
				}
			}
		}
	foreach$position(0..$length-$minimum_primer_length-1)
		{
		$multi_hit_status=0;
		$check_substr=substr($consensus,$position,$minimum_primer_length);
		$check_substr_rc=$check_substr;
		$check_substr_rc=reverse$check_substr_rc;
		$check_substr_rc=~tr/ACGTRYKMBDHV/TGCAYRMKVHDB/;
		@check_substr=split('',$check_substr);
		@check_substr_rc=split('',$check_substr_rc);
		foreach$position(@check_substr)
			{
			degenerate();
			}
		$check_substr=join('',@check_substr);
		foreach$position(@check_substr_rc)
			{
			degenerate();
			}
		$check_substr_rc=join('',@check_substr_rc);
		$sequence_search=$consensus;
		if($1)
			{
			$sequence_search=~s/^.*$check_substr/$1/i;
			}
		else
			{
			$sequence_search=~s/^.*$check_substr//i;
			}
		$new_length=length$sequence_search;
		$delta_length=$length-$new_length;
		$sequence_search=substr($consensus,0,($delta_length-1));
		if($sequence_search=~s/$check_substr//i)
			{
			$multi_hit_status=5;
			}
		elsif($consensus=~/$check_substr_rc/i)
			{
			$multi_hit_status=6;
			}
		unless($multi_hit_status==0)
			{
			foreach($position..$position+$minimum_primer_length)
				{
				unless($sequence_annotation[$_]=~/$multi_hit_status/)
					{
					$sequence_annotation[$_].="$multi_hit_status";
					}
				}
			}
		if(@reference_files>0&&$perl_or_seqmap eq "easyPAC"&&$do_sequence_annotation==1)
			{
			foreach$ref_seq(@rep_sequences)
				{
				if($ref_seq=~/$check_substr/i)
					{
					foreach($position..$position+$minimum_primer_length)
						{
						unless($sequence_annotation[$_]=~/7/)
							{
							$sequence_annotation[$_].="7";
							}
						}
					}
				elsif($ref_seq=~/$check_substr_rc/i)
					{
					foreach($position..$position+$minimum_primer_length)
						{
						unless($sequence_annotation[$_]=~/8/)
							{
							$sequence_annotation[$_].="8";
							}
						}
					}
				}
			}
		}
	if(@reference_files>0&&$perl_or_seqmap eq "SeqMap"&&$do_sequence_annotation==1)
		{
		foreach$i(0..$maximum_primer_length-$minimum_primer_length)
			{
			foreach$position(0..$length-$minimum_primer_length-1)
				{
				$sequence_id=$position;
				$check_substr=substr($consensus,$position,$minimum_primer_length+$i);
				$check_substr_rc=$check_substr;
				$check_substr_rc=reverse$check_substr_rc;
				$check_substr_rc=~tr/ACGTRYKMBDHV/TGCAYRMKVHDB/;
				$sequence=$check_substr;
				regenerate();
				$sequence=$check_substr_rc;
				regenerate();
				}
			}
		open(TEMP,">in.temp");
		print TEMP @possible_sequences;
		close TEMP;
		@possible_sequences=();
		$progress_text.="\n Launching SeqMap: ";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		$reference_file=$reference_file_name;
		start_seqmap();
		foreach(@seqmap_out)
			{
			unless($_=~/^trans_id/)
				{
				@data=split("\t",$_);
				$position=$data[0];
				$length_seq=length$data[4];
				if($_=~/\tNM\t/)
					{
					foreach($position..$position+$length_seq)
						{
						$sequence_annotation[$_].="s";
						}
					}
				else
					{
					foreach($position..$position+$length_seq)
						{
						$sequence_annotation[$_].="S";
						}
					}
				}
			}
		}
	###   prepare graphic file   ###
	$image_width=$length*6+110;
	$image_hight=($number_of_sequences*15)+($primer_pairs_in_graphical_output*20)+200;
	$im=new GD::Image->newTrueColor ($image_width,$image_hight);
	$background=$im->colorAllocate(255,255,250);
	$im->fill(1,1,$background);
	$white=$im->colorAllocate(255,255,255);
	$black=$im->colorAllocate(0,0,0);
	$green=$im->colorAllocate(0,100,0);
	$red=$im->colorAllocate(178,34,34);
	$blue=$im->colorAllocate(0,0,255);
	$yellow=$im->colorAllocate(200,160,0);
	
	# colors for reference match
	$violett[0]=$im->colorAllocate(242,209,255);
	$violett[1]=$im->colorAllocate(232,176,255);
	$violett[2]=$im->colorAllocate(222,142,255);
	$violett[3]=$im->colorAllocate(212,108,255);
	$violett[4]=$im->colorAllocate(202,77,255);
	$violett[5]=$im->colorAllocate(192,43,255);
	$violett[6]=$im->colorAllocate(182,9,255);
	$violett[7]=$im->colorAllocate(154,0,220);
	$violett[8]=$im->colorAllocate(128,0,183);
	$violett[9]=$im->colorAllocate(100,0,142);
	
	# colors for conservation
	$conservation[0]=$im->colorAllocate(0,200,30);
	$conservation[1]=$im->colorAllocate(120,200,0);
	$conservation[2]=$im->colorAllocate(200,240,20);
	$conservation[3]=$im->colorAllocate(246,253,38);
	$conservation[4]=$im->colorAllocate(253,224,38);
	$conservation[5]=$im->colorAllocate(253,181,38);
	$conservation[6]=$im->colorAllocate(253,95,38);
	$conservation[7]=$im->colorAllocate(238,21,21);
	$conservation[8]=$im->colorAllocate(200,0,0);
	
	$im->string(gdLargeFont,5,5,"Sequence alignment and primer pairs (inputfile:$alignment_file_name):",$black);
	$sequence_hight=50;	
	$letter_position=94;
	$scale_count=0;
	$scale_index_count=0;
	$multiply_scale_index=0;
	foreach(1..$length)
		{
		$scale="-";
		$scale_count++;
		$scale_index_count++;
		if($scale_count==10)
			{
			$scale="|";
			$scale_count=0;
			}
		$letter_position=$letter_position+6;
		$im->string(gdSmallFont,$letter_position,$sequence_hight,"$scale",$black);
		if($scale_index_count==50)
			{
			$multiply_scale_index++;
			$scale_index=$multiply_scale_index*50;
			$sequence_hight_index=$sequence_hight-15;
			$im->string(gdSmallFont,$letter_position,$sequence_hight_index,"$scale_index",$black);
			$scale_index_count=0;
			}
		}
	$sequence_id=-1;
	foreach$title(@titles)
		{
		$sequence_id++;
		$sequence_hight=$sequence_hight+15;
		$title=substr($title,1,12);
		$im->string(gdSmallFont,5,$sequence_hight,"$title",$black);
		$sequence=$sequences[$sequence_id];
		@sequence=split('',$sequence);
		$letter_position=94;
		foreach$letter(@sequence)
			{
			$letter_position=$letter_position+6;
			if($letter=~/A/i)
				{
				$letter_color=$green;
				}
			elsif($letter=~/T/i)
				{
				$letter_color=$red;
				}
			elsif($letter=~/[G-]/i)
				{
				$letter_color=$black;
				}
			elsif($letter=~/C/i)
				{
				$letter_color=$blue;
				}
			elsif($letter=~/N/i)
				{
				$letter_color=$violett[9];
				}
			else
				{
				$letter_color=$yellow;
				}
			$im->string(gdSmallFont,$letter_position,$sequence_hight,"$letter",$letter_color);
			}
		}
	$sequence_hight=$sequence_hight+20;
	$im->string(gdSmallFont,5,$sequence_hight,"Consensus",$black);
	@consensus=split('',$consensus);
	$letter_position=94;
	foreach$letter(@consensus)
		{
		$letter_position=$letter_position+6;
		if($letter=~/A/i)
			{
			$letter_color=$green;
			}
		elsif($letter=~/T/i)
			{
			$letter_color=$red;
			}
		elsif($letter=~/[G-]/i)
			{
			$letter_color=$black;
			}
		elsif($letter=~/C/i)
			{
			$letter_color=$blue;
			}
		elsif($letter=~/N/i)
			{
			$letter_color=$violett[9];
			}
		else
			{
			$letter_color=$yellow;
			}
		$im->string(gdSmallFont,$letter_position,$sequence_hight,"$letter",$letter_color);
		}
	$sequence_hight=$sequence_hight+20;	
	$im->string(gdSmallFont,5,$sequence_hight,"Conservation",$black);
	@variants=split('',$variants);
	$letter_position=94;
	$sequence_hight=$sequence_hight+2;
	foreach$position(1..$length)
		{
		$sum_variants=1;
		foreach($position-int(($minimum_primer_length/2)+1)..$position+int(($minimum_primer_length/2)-1))
			{
			$variants_factor=$variants[$_];
			unless($variants_factor)
				{
				$variants_factor=0;
				}
			if($variants_factor==0)
				{
				$variants_factor=$maximum_ambiguity_factor; # color will be red when more gaps than to be ignored
				}
			$sum_variants=$sum_variants*$variants_factor;
			}
		
		if($sum_variants>$maximum_ambiguity_factor)
			{
			$conservation_color=$conservation[8];
			}
		else
			{
			$conservation_color=$conservation[(int(($sum_variants/$maximum_ambiguity_factor)*8))-1];
			}
		$letter_position=$letter_position+6;
		$letter_position2=$letter_position+6;
		foreach(0..7)
			{
			$im->line($letter_position,$sequence_hight+$_,$letter_position2,$sequence_hight+$_,$conservation_color);
			}
		}
	$sequence_hight=$sequence_hight+18;	
	$im->string(gdSmallFont,5,$sequence_hight,"Annotation",$black);
	$letter_position=94;
	$annotation_text_letter=-1;
	$former_annotation_status=-1;
	foreach$annotation(@sequence_annotation)
		{
		$letter_position=$letter_position+6;
		$letter_position2=$letter_position+6;
		if($annotation=~/0/)
			{
			$annotation_color=$im->colorAllocate(50,160,30);
			$annotation_text="                         "x(int($length/25));
			@annotation_text_array=split('',$annotation_text);
			$annotation_status=0;
			}
		if($annotation=~/[78S]/)
			{
			$annotation_color=$im->colorAllocate(100,0,142);
			if($annotation=~/[7]/)
				{
				$annotation_text=" reference match (sense)  "x(int($length/26));
				@annotation_text_array=split('',$annotation_text);
				$annotation_status=7;
				}
			elsif($annotation=~/[8]/)
				{
				$annotation_text=" reference match (rc)  "x(int($length/23));
				@annotation_text_array=split('',$annotation_text);
				$annotation_status=8;
				}
			else
				{
				$s=$annotation=~tr/s/-/;
				$S=$annotation=~tr/S/-/;
				$annotation_color=$violett[(int(($S/($s+$S))*9))];
				$annotation_text=" reference match  "x(int($length/18));
				@annotation_text_array=split('',$annotation_text);
				$annotation_status=9;
				}
			}
		if($annotation=~/[456]/)
			{
			$annotation_color=$im->colorAllocate(250,180,40);
			if($annotation=~/[4]/)
				{
				$annotation_color=$im->colorAllocate(255,100,100);
				$annotation_text=" simple repeat  "x(int($length/16));
				@annotation_text_array=split('',$annotation_text);
				$annotation_status=4;
				}
			elsif($annotation=~/[5]/)
				{
				$annotation_text=" internal duplication (sense)  "x(int($length/31));
				@annotation_text_array=split('',$annotation_text);
				$annotation_status=5;
				}
			else
				{
				$annotation_text=" internal duplication (rc)  "x(int($length/28));
				@annotation_text_array=split('',$annotation_text);
				$annotation_status=6;
				}
			}
		if($annotation=~/[1]/)
			{
			$annotation_color=$im->colorAllocate(160,190,235);
			$annotation_text=" target  "x(int($length/9));
			@annotation_text_array=split('',$annotation_text);
			$annotation_status=1;
			}
		if($annotation=~/[2]/)
			{
			$annotation_color=$im->colorAllocate(80,80,80);
			$annotation_text=" excluded region  "x(int($length/18));
			@annotation_text_array=split('',$annotation_text);
			$annotation_status=2;
			}
		if($annotation=~/[3]/)
			{
			$annotation_color=$im->colorAllocate(150,150,150);
			$annotation_text=" out of range  "x(int($length/15));
			@annotation_text_array=split('',$annotation_text);
			$annotation_status=3;
			}
		foreach(0..14)
			{
			$im->line($letter_position,$sequence_hight+$_,$letter_position2,$sequence_hight+$_,$annotation_color);
			}
		if($former_annotation_status==$annotation_status)
			{
			$annotation_text_letter++;
			}
		else
			{
			$annotation_text_letter=0;
			}
		$im->string(gdSmallFont,$letter_position,$sequence_hight,"$annotation_text_array[$annotation_text_letter]",$white);
		$former_annotation_status=$annotation_status;
		}
	$progress_text.=" done.\n\n";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	
	###   SLIDING WINDOW OVER LIST OF VARIANTS (collecting proper choordinates)   ###
	$progress_text.=" collecting primers with proper ambiguity-factor and distance to target... ";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	$all_considered_forward_primer=0;
	$all_considered_reverse_primer=0;
	$add_length=-1;
	foreach(0..$maximum_primer_length-$minimum_primer_length)
		{
		$add_length++;
		$primer_length=$minimum_primer_length+$add_length;
		$forward_primer_start_choordinate=-1;
		foreach(0..$PCR_target_start-$primer_length-1)
			{
			$primer_in_ex_region=0;
			$forward_primer_start_choordinate++;
			$forward_primer_end_choordinate=$forward_primer_start_choordinate+$primer_length-1;
			$forward_primer_variants_string=substr($variants,$forward_primer_start_choordinate,$primer_length);
			unless($forward_primer_variants_string=~/0/)
				{
				$ambiguity_factor=1;
				@forward_primer_variants_array=split('',$forward_primer_variants_string);
				foreach$factor(@forward_primer_variants_array)
					{
					$ambiguity_factor=$ambiguity_factor*$factor;
					}
				$all_considered_forward_primer++;
				unless($ambiguity_factor>$maximum_ambiguity_factor)
					{
					if(@excluded_regions)
						{
						foreach(@excluded_regions)
							{
							$exclude_start=$_;
							$exclude_start=~s/-.*$//;
							$exclude_start=$exclude_start-1;
							$exclude_end=$_;
							$exclude_end=~s/^.*-//;
							$exclude_end=$exclude_end-1;
							if($forward_primer_start_choordinate>=$exclude_start&&$forward_primer_start_choordinate<=$exclude_end)
								{
								$primer_in_ex_region=1;
								}
							elsif($forward_primer_end_choordinate>=$exclude_start&&$forward_primer_end_choordinate<=$exclude_end)
								{
								$primer_in_ex_region=1;
								}
							elsif($exclude_start>=$forward_primer_start_choordinate&&$exclude_start<=$forward_primer_end_choordinate)
								{
								$primer_in_ex_region=1;
								}
							}
						}
					if(($PCR_target_start-$forward_primer_start_choordinate)+($PCR_target_end-$PCR_target_start)+1>$maximum_product_size)
						{
						$primer_in_ex_region=1;
						}
					unless($primer_in_ex_region==1)
						{
						$forward_primer_choordinates_00="$forward_primer_start_choordinate-$forward_primer_end_choordinate";
						push(@forward_primers_choordinates_00,$forward_primer_choordinates_00);
						push(@ambiguities_forward_00,$ambiguity_factor);
						}
					}
				}
			}
		}
	$add_length=-1;
	foreach(0..$maximum_primer_length-$minimum_primer_length)
		{
		$add_length++;
		$primer_length=$minimum_primer_length+$add_length;
		$reverse_primer_start_choordinate=$PCR_target_end-1;
		foreach($PCR_target_end..$length-$primer_length)
			{
			$primer_in_ex_region=0;
			$reverse_primer_start_choordinate++;
			$reverse_primer_end_choordinate=$reverse_primer_start_choordinate+$primer_length-1;
			$reverse_primer_variants_string=substr($variants,$reverse_primer_start_choordinate,$primer_length);
			unless($reverse_primer_variants_string=~/0/)
				{
				$ambiguity_factor=1;
				@reverse_primer_variants_array=split('',$reverse_primer_variants_string);
				foreach$factor(@reverse_primer_variants_array)
					{
					$ambiguity_factor=$ambiguity_factor*$factor;
					}
				$all_considered_reverse_primer++;
				unless($ambiguity_factor>$maximum_ambiguity_factor)
					{
					if(@excluded_regions)
						{
						foreach(@excluded_regions)
							{
							$exclude_start=$_;
							$exclude_start=~s/-.*$//;
							$exclude_start=$exclude_start-1;
							$exclude_end=$_;
							$exclude_end=~s/^.*-//;
							$exclude_end=$exclude_end-1;
							if($reverse_primer_start_choordinate>=$exclude_start&&$reverse_primer_start_choordinate<=$exclude_end)
								{
								$primer_in_ex_region=1;
								}
							elsif($reverse_primer_end_choordinate>=$exclude_start&&$reverse_primer_end_choordinate<=$exclude_end)
								{
								$primer_in_ex_region=1;
								}
							elsif($exclude_start>=$reverse_primer_start_choordinate&&$exclude_start<=$reverse_primer_end_choordinate)
								{
								$primer_in_ex_region=1;
								}
							}
						}
					if(($reverse_primer_end_choordinate-$PCR_target_end)+($PCR_target_end-$PCR_target_start)+1>$maximum_product_size)
						{
						$primer_in_ex_region=1;
						}
					unless($primer_in_ex_region==1)
						{
						$reverse_primer_choordinates_00="$reverse_primer_start_choordinate-$reverse_primer_end_choordinate";
						push(@reverse_primers_choordinates_00,$reverse_primer_choordinates_00);
						push(@ambiguities_reverse_00,$ambiguity_factor);
						}
					}
				}
			}
		}

	###   ASSEMBLING PRIMER (from proper choordinates)   ###
	unless($given_forward_primer)
		{
		foreach$forward_choordinates(@forward_primers_choordinates_00)
			{
			@choordinates=split('-',$forward_choordinates);
			$forward_primer=substr($consensus,$choordinates[0],(($choordinates[1]-$choordinates[0])+1));
			push(@forward_primers_00,$forward_primer);
			}
		}
	unless($given_reverse_primer)
		{
		foreach$reverse_choordinates(@reverse_primers_choordinates_00)
			{
			@choordinates=split('-',$reverse_choordinates);
			$reverse_primer=substr($consensus,$choordinates[0],(($choordinates[1]-$choordinates[0])+1));
			$reverse_primer=reverse$reverse_primer;
			$reverse_primer=~tr/ACGTRYSWKMBDHV/TGCAYRWSMKVHDB/;
			push(@reverse_primers_00,$reverse_primer);
			}
		}
	# take predefined primers #
	if($given_forward_primer)
		{
		@forward_primers_00=($given_forward_primer);
		unless ($consensus=~/$given_forward_primer/i)
			{
			$start_smartprime->messageBox(-message=>"Defined forward primer is not in consensus!\n Incongruous or more degenerated than necessary. PLEASE CHECK!",-type=>'ok',-icon=>'error');
			$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
			}
		# get coordinates #
		$gc_consensus=$consensus;
		$gc_consensus=~s/$given_forward_primer.*$//;
		$start_coordinate=length$gc_consensus;
		$end_coordinate=$start_coordinate+(length$given_forward_primer)-1;
		$forward_primers_choordinates_00[0]="$start_coordinate-$end_coordinate";
		}
	if($given_reverse_primer)
		{
		@reverse_primers_00=($given_reverse_primer);
		$check_given_reverse_primer=reverse$given_reverse_primer;
		$check_given_reverse_primer=~tr/ACGTRYSWKMBDHV/TGCAYRWSMKVHDB/;
		unless ($consensus=~/$check_given_reverse_primer/i)
			{
			$start_smartprime->messageBox(-message=>"Defined reverse primer is not in consensus!\n Incongruous or more degenerated than necessary. PLEASE CHECK!",-type=>'ok',-icon=>'error');
			$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
			}
		# get coordinates #
		$gc_consensus=$consensus;
		$gc_consensus=~s/$check_given_reverse_primer.*$//;
		$start_coordinate=length$gc_consensus;
		$end_coordinate=$start_coordinate+(length$given_reverse_primer)-1;
		$reverse_primers_choordinates_00[0]="$start_coordinate-$end_coordinate";
		}
	$forward_primers_proper_abiguity=@forward_primers_00;
	$reverse_primers_proper_abiguity=@reverse_primers_00;
	$progress_text.="done.\n (forward: $forward_primers_proper_abiguity / reverse: $reverse_primers_proper_abiguity)\n\n";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;

	###   REJECTING UNPROPER 3'-ENDS   ###
	$primer_3'_end=~s/R/[RAG]/ig;
	$primer_3'_end=~s/Y/[YCT]/ig;
	$primer_3'_end=~s/S/[SGC]/ig;
	$primer_3'_end=~s/W/[WAT]/ig;
	$primer_3'_end=~s/K/[KGT]/ig;
	$primer_3'_end=~s/M/[MAC]/ig;
	$primer_3'_end=~s/B/[YSKTGC]/ig;
	$primer_3'_end=~s/D/[RWKAGT]/ig;
	$primer_3'_end=~s/H/[YAMACT]/ig;
	$primer_3'_end=~s/V/[RSMACG]/ig;
	$primer_3'_end=~s/N/[ATGCRYSWKMBDHVN]/ig;
	$progress_text.=" rejecting primers that do not end with $primer_3'_end_original... ";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	$primer_id=-1;
	foreach$forward_primer(@forward_primers_00)
		{
		$primer_id++;
		if($forward_primer=~/^.*$primer_3'_end$/i)
			{
			push(@forward_primers_01,$forward_primer);
			push(@forward_primers_choordinates_01,$forward_primers_choordinates_00[$primer_id]);
			push(@ambiguities_forward_01,$ambiguities_forward_00[$primer_id]);
			}
		}
	$primer_id=-1;
	foreach$reverse_primer(@reverse_primers_00)
		{
		$primer_id++;
		if($reverse_primer=~/^.*$primer_3'_end$/i)
			{
			push(@reverse_primers_01,$reverse_primer);
			push(@reverse_primers_choordinates_01,$reverse_primers_choordinates_00[$primer_id]);
			push(@ambiguities_reverse_01,$ambiguities_reverse_00[$primer_id]);
			}
		}
	$forward_primers_proper_3'_end=@forward_primers_01;
	$reverse_primers_proper_3'_end=@reverse_primers_01;
	$progress_text.="done.\n (forward: $forward_primers_proper_3'_end / reverse: $reverse_primers_proper_3'_end)\n\n";
	if($given_forward_primer && $forward_primers_proper_3'_end==0)
		{
		$progress_text.=" Defined forward primer exhibits unproper 3'-end!\n\n";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		sleep(5);exit;
		}
	if($given_reverse_primer && $reverse_primers_proper_3'_end==0)
		{
		$progress_text.=" Defined reverse primer exhibits unproper 3'-end!\n\n";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		sleep(5);exit;
		}

	###   COMPUTING Tm AND GC-CONTENT   ###
	$progress_text.=" rejecting primers with unproper Tm or GC-content... ";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	foreach$forward_primer(@forward_primers_01)
		{
		$forward_primer_length=length$forward_primer;
		$forward_primer_minimumGC=$forward_primer;
		$forward_primer_maximumGC=$forward_primer;
		$forward_primer_maximumGC=~tr/MRSYKVHDBN/CCCCCCCCCC/;
		@single_nt_minimum=split('',$forward_primer_minimumGC);
		@single_nt_maximum=split('',$forward_primer_maximumGC);	
		$GC_minimum=0;
		foreach$single_nt(@single_nt_minimum)
			{
			if ($single_nt=~/[GC]/i)
				{
				$GC_minimum++;
				}
			}
		$GC_content_minimum=($GC_minimum/$forward_primer_length)*100;
		$GC_maximum=0;
		foreach$single_nt(@single_nt_maximum)
			{
			if ($single_nt=~/[GC]/i)
				{
				$GC_maximum++;
				}
			}
		$GC_content_maximum=($GC_maximum/$forward_primer_length)*100;
		if($method_of_Tm_calculation eq "basic")
			{
			$Tm_minimum=64.9+41*($GC_minimum-16.4)/$forward_primer_length;
			$Tm_maximum=64.9+41*($GC_maximum-16.4)/$forward_primer_length;
			}
		else
			{
			$primer=$forward_primer;
			Tm_nearest_neighbor();
			}
		push(@Tms_forward_01,"$Tm_minimum-$Tm_maximum");
		push(@GC_forward_01,"$GC_content_minimum-$GC_content_maximum");
		}
	foreach$reverse_primer(@reverse_primers_01)
		{
		$reverse_primer_length=length$reverse_primer;
		$reverse_primer_minimumGC=$reverse_primer;
		$reverse_primer_maximumGC=$reverse_primer;
		$reverse_primer_maximumGC=~tr/MRSYKVHDBN/CCCCCCCCCC/;
		@single_nt_minimum=split('',$reverse_primer_minimumGC);
		@single_nt_maximum=split('',$reverse_primer_maximumGC);	
		$GC_minimum=0;
		foreach$single_nt(@single_nt_minimum)
			{
			if ($single_nt=~/[GC]/i)
				{
				$GC_minimum++;
				}
			}
		$GC_content_minimum=($GC_minimum/$reverse_primer_length)*100;
		$GC_maximum=0;
		foreach$single_nt(@single_nt_maximum)
			{
			if ($single_nt=~/[GC]/i)
				{
				$GC_maximum++;
				}
			}
		$GC_content_maximum=($GC_maximum/$reverse_primer_length)*100;
		if($method_of_Tm_calculation eq "basic")
			{
			$Tm_minimum=64.9+41*($GC_minimum-16.4)/$reverse_primer_length;
			$Tm_maximum=64.9+41*($GC_maximum-16.4)/$reverse_primer_length;
			}
		else
			{
			$primer=$reverse_primer;
			Tm_nearest_neighbor();
			}
		push(@Tms_reverse_01,"$Tm_minimum-$Tm_maximum");
		push(@GC_reverse_01,"$GC_content_minimum-$GC_content_maximum");
		}

	###   REJECTING TO HIGH / TO LOW Tm AND GC   ###
	$primer_id=-1;
	foreach$Tm(@Tms_forward_01)
		{
		$primer_id++;
		@min_max_Tm=split('-',$Tm);
		@min_max_GC=split('-',$GC_forward_01[$primer_id]);
		$min_Tm=$min_max_Tm[0];
		$max_Tm=$min_max_Tm[1];
		$min_GC=$min_max_GC[0];
		$max_GC=$min_max_GC[1];	
		if($min_Tm>=$minimum_Tm && $max_Tm<=$maximum_Tm && ($max_Tm-$min_Tm)<=$maximum_delta_Tm && $min_GC>=$minimum_GC && $max_GC<=$maximum_GC)
			{
			push(@forward_primers_choordinates_02,$forward_primers_choordinates_01[$primer_id]);
			push(@ambiguities_forward_02,$ambiguities_forward_01[$primer_id]);
			push(@forward_primers_02,$forward_primers_01[$primer_id]);	
			push(@Tms_forward_02,"$min_Tm-$max_Tm");		
			if($min_GC==$max_GC)
				{
				push(@GC_forward_02,$min_GC);
				}
			else
				{
				push(@GC_forward_02,"$min_GC-$max_GC");
				}
			}
		}
	$primer_id=-1;
	foreach$Tm(@Tms_reverse_01)
		{
		$primer_id++;
		@min_max_Tm=split('-',$Tm);
		@min_max_GC=split('-',$GC_reverse_01[$primer_id]);
		$min_Tm=$min_max_Tm[0];
		$max_Tm=$min_max_Tm[1];
		$min_GC=$min_max_GC[0];
		$max_GC=$min_max_GC[1];	
		if($min_Tm>=$minimum_Tm && $max_Tm<=$maximum_Tm && ($max_Tm-$min_Tm)<=$maximum_delta_Tm && $min_GC>=$minimum_GC && $max_GC<=$maximum_GC)
			{
			push(@reverse_primers_choordinates_02,$reverse_primers_choordinates_01[$primer_id]);
			push(@ambiguities_reverse_02,$ambiguities_reverse_01[$primer_id]);
			push(@reverse_primers_02,$reverse_primers_01[$primer_id]);
			push(@Tms_reverse_02,"$min_Tm-$max_Tm");
			if($min_GC==$max_GC)
				{
				push(@GC_reverse_02,$min_GC);
				}
			else
				{
				push(@GC_reverse_02,"$min_GC-$max_GC");
				}
			}
		}
	$forward_primers_proper_GC_Tm=@forward_primers_02;
	$reverse_primers_proper_GC_Tm=@reverse_primers_02;
	$progress_text.="done.\n (forward: $forward_primers_proper_GC_Tm / reverse: $reverse_primers_proper_GC_Tm)\n\n";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	if($given_forward_primer&&$forward_primers_proper_GC_Tm==0)
		{
		$start_smartprime->messageBox(-message=>"Defined forward primer exhibits unproper Tm and/or GC-content!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}
	if($given_reverse_primer&&$reverse_primers_proper_GC_Tm==0)
		{
		$start_smartprime->messageBox(-message=>"Defined reverse primer exhibits unproper Tm and/or GC-content!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}

	###   REJECTING TOO MUCH POLY-X/XY   ###
	$progress_text.=" rejecting primers with too much poly-X/XY... ";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	@poly_X=("[ARWMDHVN]","[TYWKBDHN]","[GRSKBDVN]","[CYSMBHVN]");
	@poly_X_combine=@poly_X;
	foreach$nucleotide(@poly_X)
		{	
		foreach$nucleotide2(@poly_X_combine)
			{
			push(@poly_XY,"$nucleotide$nucleotide2");
			}
		}
	$primer_id=-1;
	foreach$forward_primer(@forward_primers_02)
		{
		$primer_id++;
		$poly_X_status=0;
		$poly_XY_status=0;
		foreach$poly_X(@poly_X)
			{
			$poly_X_search="";
			foreach(0..$maximum_poly_X)
				{
				$poly_X_search=$poly_X_search.$poly_X;
				}
			if($forward_primer=~/$poly_X_search/i)
				{
				$poly_X_status=1;
				}
			}
		foreach$poly_XY(@poly_XY)
			{
			$poly_XY_search="";
			foreach(0..$maximum_poly_XY)
				{
				$poly_XY_search=$poly_XY_search.$poly_XY;
				}
			if($forward_primer=~/$poly_XY_search/i)
				{
				$poly_XY_status=1;
				}
			}
		if($poly_X_status==0 && $poly_XY_status==0)
			{
			push(@forward_primers_choordinates_03,$forward_primers_choordinates_02[$primer_id]);
			push(@ambiguities_forward_03,$ambiguities_forward_02[$primer_id]);
			push(@forward_primers_03,$forward_primer);
			push(@Tms_forward_03,$Tms_forward_02[$primer_id]);
			push(@GC_forward_03,$GC_forward_02[$primer_id]);
			}
		}
	$primer_id=-1;
	foreach$reverse_primer(@reverse_primers_02)
		{
		$primer_id++;
		$poly_X_status=0;
		$poly_XY_status=0;
		foreach$poly_X(@poly_X)
			{
			$poly_X_search="";
			foreach(0..$maximum_poly_X)
				{
				$poly_X_search=$poly_X_search.$poly_X;
				}
			if($reverse_primer=~/$poly_X_search/i)
				{
				$poly_X_status=1;
				}
			}
		foreach$poly_XY(@poly_XY)
			{
			$poly_XY_search="";
			foreach(0..$maximum_poly_XY)
				{
				$poly_XY_search=$poly_XY_search.$poly_XY;
				}
			if($reverse_primer=~/$poly_XY_search/i)
				{
				$poly_XY_status=1;
				}
			}
		if($poly_X_status==0 && $poly_XY_status==0)
			{
			push(@reverse_primers_choordinates_03,$reverse_primers_choordinates_02[$primer_id]);
			push(@ambiguities_reverse_03,$ambiguities_reverse_02[$primer_id]);
			push(@reverse_primers_03,$reverse_primer);
			push(@Tms_reverse_03,$Tms_reverse_02[$primer_id]);
			push(@GC_reverse_03,$GC_reverse_02[$primer_id]);
			}
		}
	$forward_primers_polyXY=@forward_primers_03;
	$reverse_primers_polyXY=@reverse_primers_03;
	$progress_text.="done.\n (forward: $forward_primers_polyXY / reverse: $reverse_primers_polyXY)\n\n";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	if($given_forward_primer && $forward_primers_polyXY==0)
		{
		$start_smartprime->messageBox(-message=>"Defined forward primer exhibits unaccceptable amount of poly-X/XY!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}
	if($given_reverse_primer && $reverse_primers_polyXY==0)
		{
		$start_smartprime->messageBox(-message=>"Defined reverse primer exhibits unaccceptable amount of poly-X/XY!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}

	###   REJECTING PRIMERS WITH TO HIGH 3'-END STABILITY   ###
	$progress_text.=" rejecting primers with too high 3'-end stability... ";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	$primer_id=-1;
	foreach$primer(@forward_primers_03)
		{
		$primer_id++;
		end_stability();
		if($end_stability>=($maximum_3'_stability*-1))
			{
			push(@good_end_stability_forward_primer,$primer);
			push(@good_end_stability_forward_choordinates,$forward_primers_choordinates_03[$primer_id]);
			push(@good_end_stability_forward_ambiguities,$ambiguities_forward_03[$primer_id]);
			push(@good_end_stability_forward_Tms,$Tms_forward_03[$primer_id]);
			push(@good_end_stability_forward_GC,$GC_forward_03[$primer_id]);
			}
		}
	$primer_id=-1;
	foreach$primer(@reverse_primers_03)
		{
		$primer_id++;
		end_stability();
		if($end_stability>=($maximum_3'_stability*-1))
			{
			push(@good_end_stability_reverse_primer,$primer);
			push(@good_end_stability_reverse_choordinates,$reverse_primers_choordinates_03[$primer_id]);
			push(@good_end_stability_reverse_ambiguities,$ambiguities_reverse_03[$primer_id]);
			push(@good_end_stability_reverse_Tms,$Tms_reverse_03[$primer_id]);
			push(@good_end_stability_reverse_GC,$GC_reverse_03[$primer_id]);
			}
		}
	@forward_primers_choordinates_03=@good_end_stability_forward_choordinates;
	@ambiguities_forward_03=@good_end_stability_forward_ambiguities;
	@forward_primers_03=@good_end_stability_forward_primer;
	@Tms_forward_03=@good_end_stability_forward_Tms;
	@GC_forward_03=@good_end_stability_forward_GC;
	@reverse_primers_choordinates_03=@good_end_stability_reverse_choordinates;
	@ambiguities_reverse_03=@good_end_stability_reverse_ambiguities;
	@reverse_primers_03=@good_end_stability_reverse_primer;
	@Tms_reverse_03=@good_end_stability_reverse_Tms;
	@GC_reverse_03=@good_end_stability_reverse_GC;
	$forward_primers_stability=@forward_primers_choordinates_03;
	$reverse_primers_stability=@reverse_primers_choordinates_03;
	$progress_text.="done.\n (forward: $forward_primers_stability / reverse: $reverse_primers_stability)\n\n";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	if($given_forward_primer&&$forward_primers_stability==0)
		{
		$start_smartprime->messageBox(-message=>"Defined forward primer exhibits unaccceptable 3'-end stability!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}
	if($given_reverse_primer&&$reverse_primers_stability==0)
		{
		$start_smartprime->messageBox(-message=>"Defined reverse primer exhibits unaccceptable 3'-end stability!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}

	###   COMPUTING 3'-SELF-COMPLEMENTARITY SCORE   ###
	$progress_text.=" rejecting primers with too high 3'-self-complementarity score... \n\n";
	$progress_text.=" 0%                                    50%                                     100%\n";
	$progress_text.=" |--------------------------------------|---------------------------------------|\n ";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	$one_eightieth_progress=($forward_primers_polyXY+$reverse_primers_polyXY)/80;
	$primer_id=-1;
	$count_progress=0;
	$printed_dots=0;
	foreach$primer(@forward_primers_03)
		{
		$primer_id++;
		$count_progress++;
		if($count_progress>$one_eightieth_progress)
			{
			$progress_text.=".";
			$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
			$count_progress=0;
			$printed_dots++;
			}
		@complementarity_scores=();
		@primers_a=();
		@primers_b=();
		$primer_a=$primer;
		$primer_b=$primer;
		$primer_b=reverse$primer_b;
		$primer_b=~tr/ACGTRYKMBDHV/TGCAYRMKVHDB/;
		$length_primer_a=length$primer_a;
		$length_primer_b=length$primer_b;
		push(@primers_a,$primer_a);
		push(@primers_b,$primer_b);
		$gap_position=0;
		foreach(0..$length_primer_b-2)
			{
			$gap_position++;
			$before_gap=substr($primer_b,0,$gap_position);
			$after_gap=substr($primer_b,$_+1);
			$gapped_primer="$before_gap"."-"."$after_gap";
			push(@primers_b,$gapped_primer);
			}
		do_comparisons();
		$gap_position=0;
		foreach(0..$length_primer_a-2)
			{
			$gap_position++;
			$before_gap=substr($primer_a,0,$gap_position);
			$after_gap=substr($primer_a,$_+1);
			$gapped_primer="$before_gap"."-"."$after_gap";
			push(@primers_a,$gapped_primer);
			}
		shift@primers_a;
		@primers_b=("$primer_b");
		do_comparisons();
		sub do_comparisons
			{
			foreach$primer_a(@primers_a)
				{		
				@primer_a=split('',$primer_a);
				$nucleotides_a=@primer_a;
				foreach(@primer_a)
					{
					$_=~s/M/[MAC]/g;
					$_=~s/R/[RAG]/g;
					$_=~s/W/[WAT]/g;
					$_=~s/S/[SCG]/g;
					$_=~s/Y/[YCT]/g;
					$_=~s/K/[KGT]/g;
					$_=~s/V/[VACGMRS]/g;
					$_=~s/H/[HACTMWY]/g;
					$_=~s/D/[DAGTRWK]/g;
					$_=~s/B/[BCGTSYK]/g;
					$_=~s/N/[AGTCMRWSYKVHDBN]/g;
					}
				foreach$primer_b(@primers_b)
					{
					@primer_b=split('',$primer_b);
					$nucleotides_b=@primer_b;
					if($nucleotides_a>$nucleotides_b)
						{
						$comparisons=$nucleotides_b;
						}
					else
						{
						$comparisons=$nucleotides_a;
						}
					foreach(@primer_b)
						{
						$_=~s/M/[MAC]/g;
						$_=~s/R/[RAG]/g;
						$_=~s/W/[WAT]/g;
						$_=~s/S/[SCG]/g;
						$_=~s/Y/[YCT]/g;
						$_=~s/K/[KGT]/g;
						$_=~s/V/[VACGMRS]/g;
						$_=~s/H/[HACTMWY]/g;
						$_=~s/D/[DAGTRWK]/g;
						$_=~s/B/[BCGTSYK]/g;
						$_=~s/N/[AGTCMRWSYKVHDBN]/g;	
						}
					foreach$iteration(1..$comparisons)
						{
						$complementarity_score=0;
						foreach(1..$iteration)
							{
							$compare_a=$primer_a[$nucleotides_a-$iteration+$_-1];
							$compare_b=$primer_b[$_-1];
							if($compare_a=~/$compare_b/i || $compare_b=~/$compare_a/i)
								{
								$complementarity_score=$complementarity_score+1;
								}
							elsif($compare_a=~/-/ || $compare_b=~/-/)
								{
								$complementarity_score=$complementarity_score-2;
								}
							else
								{
								$complementarity_score=$complementarity_score-1;
								}
							}
						push(@complementarity_scores,$complementarity_score);
						}			
					}
				}
			}
		@sorted_complementarity_scores=sort{$b<=>$a}@complementarity_scores;
		$highest_score=shift@sorted_complementarity_scores;
		unless($highest_score>$maximum_3'_complementarity)
			{
			push(@forward_primers_choordinates_04,$forward_primers_choordinates_03[$primer_id]);
			push(@ambiguities_forward_04,$ambiguities_forward_03[$primer_id]);
			push(@forward_primers_04,$primer);
			push(@Tms_forward_04,$Tms_forward_03[$primer_id]);
			push(@GC_forward_04,$GC_forward_03[$primer_id]);
			}
		}
	$primer_id=-1;
	foreach$primer(@reverse_primers_03)
		{
		$primer_id++;
		$count_progress++;
		if($count_progress>$one_eightieth_progress)
			{
			$progress_text.=".";
			$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
			$count_progress=0;
			$printed_dots++;
			}
		@complementarity_scores=();
		@primers_a=();
		@primers_b=();
		$primer_a=$primer;
		$primer_b=$primer;
		$primer_b=reverse$primer_b;
		$primer_b=~tr/ACGTRYKMBDHV/TGCAYRMKVHDB/;
		$length_primer_a=length$primer_a;
		$length_primer_b=length$primer_b;
		push(@primers_a,$primer_a);
		push(@primers_b,$primer_b);
		$gap_position=0;
		foreach(0..$length_primer_b-2)
			{
			$gap_position++;
			$before_gap=substr($primer_b,0,$gap_position);
			$after_gap=substr($primer_b,$_+1);
			$gapped_primer="$before_gap"."-"."$after_gap";
			push(@primers_b,$gapped_primer);
			}
		do_comparisons();
		$gap_position=0;
		foreach(0..$length_primer_a-2)
			{
			$gap_position++;
			$before_gap=substr($primer_a,0,$gap_position);
			$after_gap=substr($primer_a,$_+1);
			$gapped_primer="$before_gap"."-"."$after_gap";
			push(@primers_a,$gapped_primer);
			}
		shift@primers_a;
		@primers_b=("$primer_b");
		do_comparisons();
		@sorted_complementarity_scores=sort{$b<=>$a}@complementarity_scores;
		$highest_score=shift@sorted_complementarity_scores;
		unless($highest_score>$maximum_3'_complementarity)
			{
			push(@reverse_primers_choordinates_04,$reverse_primers_choordinates_03[$primer_id]);
			push(@ambiguities_reverse_04,$ambiguities_reverse_03[$primer_id]);
			push(@reverse_primers_04,$primer);
			push(@Tms_reverse_04,$Tms_reverse_03[$primer_id]);
			push(@GC_reverse_04,$GC_reverse_03[$primer_id]);
			}
		}
	$forward_primers_selfcomplement=@forward_primers_04;
	$reverse_primers_selfcomplement=@reverse_primers_04;
	if($printed_dots<80)
		{
		foreach($printed_dots..79)
			{
			$progress_text.=".";
			$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
			}
		}
	$progress_text.="\n (forward: $forward_primers_selfcomplement / reverse: $reverse_primers_selfcomplement)\n\n";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	if($given_forward_primer && $forward_primers_selfcomplement==0)
		{
		$start_smartprime->messageBox(-message=>"Defined forward primer exhibits too high self complementarity score!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}
	if($given_reverse_primer && $reverse_primers_selfcomplement==0)
		{
		$start_smartprime->messageBox(-message=>"Defined reverse primer exhibits too high self complementarity score!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}

	###   FILTERING REFERENCE MATCHING PRIMER   ###
	if(@reference_files>0&&$perl_or_seqmap eq "easyPAC")
		{
		$progress_text.=" rejecting primers that match to reference file... \n\n";
		$progress_text.=" 0%                                    50%                                     100%\n";
		$progress_text.=" |--------------------------------------|---------------------------------------|\n ";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		$one_eightieth_progress=($forward_primers_selfcomplement+$reverse_primers_selfcomplement)/80;
		$primer_id=-1;
		$count_progress=0;
		$printed_dots=0;
		foreach$forward_primer(@forward_primers_04)
			{
			$index=0;
			$primer_id++;
			$count_progress++;
			if($count_progress>$one_eightieth_progress)
				{
				$progress_text.=".";
				$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
				$count_progress=0;
				$printed_dots++;
				}
			$forward_primer_original=$forward_primer;
			$forward_primer_rc=$forward_primer;
			$forward_primer_rc=reverse$forward_primer_rc;
			$forward_primer_rc=~tr/ACGTRYKMBDHV/TGCAYRMKVHDB/;
			if($mismatch_perl==1)
				{
				@mismatch_forward_primer=();
				@mismatch_forward_primer_rc=();
				@split_forward_primer=split('',$forward_primer);
				@split_forward_primer_rc=split('',$forward_primer_rc);
				foreach$position(@split_forward_primer)
					{
					degenerate();
					}
				foreach$position(@split_forward_primer_rc)
					{
					degenerate();
					}
				foreach(0..(length$forward_primer)-1)
					{
					unless($_==0)
						{
						$split_forward_primer[$_-1]=substr($split_forward_primer[$_-1],0,-3);
						$split_forward_primer_rc[$_-1]=substr($split_forward_primer_rc[$_-1],0,-3);
						}
					$split_forward_primer[$_]=$split_forward_primer[$_]."?.?";
					$mismatch_forward_primer=join('',@split_forward_primer);
					push(@mismatch_forward_primer,$mismatch_forward_primer);
					$split_forward_primer_rc[$_]=$split_forward_primer_rc[$_]."?.?";
					$mismatch_forward_primer_rc=join('',@split_forward_primer_rc);
					push(@mismatch_forward_primer_rc,$mismatch_forward_primer_rc);
					}
				foreach$rep_sequence(@rep_sequences)
					{
					unless($index==1)
						{
						foreach$mismatch_forward_primer(@mismatch_forward_primer)
							{
							if($rep_sequence=~/$mismatch_forward_primer/i)
								{
								$index=1;
								}
							}
						unless($index==1)
							{
							foreach$mismatch_forward_primer_rc(@mismatch_forward_primer_rc)
								{
								if($rep_sequence=~/$mismatch_forward_primer_rc/i)
									{
									$index=1;
									}
								}
							}
						}
					}
				}
			else
				{
				@forward_primer=split('',$forward_primer);
				@forward_primer_rc=split('',$forward_primer_rc);
				foreach$position(@forward_primer)
					{
					degenerate();
					}
				$forward_primer=join('',@forward_primer);
				foreach$position(@forward_primer_rc)
					{
					degenerate();
					}
				$forward_primer_rc=join('',@forward_primer_rc);
				foreach$rep_sequence(@rep_sequences)
					{
					unless($index==1)
						{
						if($rep_sequence=~/$forward_primer/i||$rep_sequence=~/$forward_primer_rc/i)
							{
							$index=1;
							}
						}
					}
				}
			if($index==0)
				{
				push(@forward_primers_choordinates_05,$forward_primers_choordinates_04[$primer_id]);
				push(@ambiguities_forward_05,$ambiguities_forward_04[$primer_id]);
				push(@forward_primers_05,$forward_primer_original);
				push(@Tms_forward_05,$Tms_forward_04[$primer_id]);
				push(@GC_forward_05,$GC_forward_04[$primer_id]);
				}
			}
		$primer_id=-1;
		foreach$reverse_primer(@reverse_primers_04)
			{
			$index=0;
			$primer_id++;
			$count_progress++;
			if($count_progress>$one_eightieth_progress)
				{
				$progress_text.=".";
				$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
				$count_progress=0;
				$printed_dots++;
				}
			$reverse_primer_original=$reverse_primer;
			$reverse_primer_rc=$reverse_primer;
			$reverse_primer_rc=reverse$reverse_primer_rc;
			$reverse_primer_rc=~tr/ACGTRYKMBDHV/TGCAYRMKVHDB/;
			if($mismatch_perl==1)
				{
				@mismatch_reverse_primer=();
				@mismatch_reverse_primer_rc=();
				@split_reverse_primer=split('',$reverse_primer);
				@split_reverse_primer_rc=split('',$reverse_primer_rc);
				foreach$position(@split_reverse_primer)
					{
					degenerate();
					}
				foreach$position(@split_reverse_primer_rc)
					{
					degenerate();
					}
				foreach(0..(length$reverse_primer)-1)
					{
					unless($_==0)
						{
						$split_reverse_primer[$_-1]=substr($split_reverse_primer[$_-1],0,-3);
						$split_reverse_primer_rc[$_-1]=substr($split_reverse_primer_rc[$_-1],0,-3);
						}
					$split_reverse_primer[$_]=$split_reverse_primer[$_]."?.?";
					$mismatch_reverse_primer=join('',@split_reverse_primer);
					push(@mismatch_reverse_primer,$mismatch_reverse_primer);
					$split_reverse_primer_rc[$_]=$split_reverse_primer_rc[$_]."?.?";
					$mismatch_reverse_primer_rc=join('',@split_reverse_primer_rc);
					push(@mismatch_reverse_primer_rc,$mismatch_reverse_primer_rc);
					}
				foreach$rep_sequence(@rep_sequences)
					{
					unless($index==1)
						{
						foreach$mismatch_reverse_primer(@mismatch_reverse_primer)
							{
							if($rep_sequence=~/$mismatch_reverse_primer/i)
								{
								$index=1;
								}
							}
						unless($index==1)
							{
							foreach$mismatch_reverse_primer_rc(@mismatch_reverse_primer_rc)
								{
								if($rep_sequence=~/$mismatch_reverse_primer_rc/i)
									{
									$index=1;
									}
								}
							}
						}
					}
				}
			else
				{
				@reverse_primer=split('',$reverse_primer);
				@reverse_primer_rc=split('',$reverse_primer_rc);
				foreach$position(@reverse_primer)
					{
					degenerate();
					}
				$reverse_primer=join('',@reverse_primer);
				foreach$position(@reverse_primer_rc)
					{
					degenerate();
					}
				$reverse_primer_rc=join('',@reverse_primer_rc);
				foreach$rep_sequence(@rep_sequences)
					{
					unless($index==1)
						{
						if($rep_sequence=~/$reverse_primer/i||$rep_sequence=~/$reverse_primer_rc/i)
							{
							$index=1;
							}
						}
					}
				}
			if($index==0)
				{
				push(@reverse_primers_choordinates_05,$reverse_primers_choordinates_04[$primer_id]);
				push(@ambiguities_reverse_05,$ambiguities_reverse_04[$primer_id]);
				push(@reverse_primers_05,$reverse_primer_original);
				push(@Tms_reverse_05,$Tms_reverse_04[$primer_id]);
				push(@GC_reverse_05,$GC_reverse_04[$primer_id]);
				}
			}
		$forward_primers_repeat=@forward_primers_05;
		$reverse_primers_repeat=@reverse_primers_05;
		if($printed_dots<80)
			{
			foreach($printed_dots..79)
				{
				$progress_text.=".";
				$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
				}
			}
		$progress_text.="\n (forward: $forward_primers_repeat / reverse: $reverse_primers_repeat)\n\n";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		}
	elsif(@reference_files>0&&$perl_or_seqmap eq "SeqMap")
		{
		$progress_text.=" rejecting primers that match to reference file... ";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		open(TEMP,">in.temp");
		$seq_id=-1;
		foreach$forward_primer(@forward_primers_04)
			{
			$seq_id++;
			$sequence_id="f".$seq_id;
			$sequence=$forward_primer;
			regenerate();
			print TEMP @possible_sequences;
			@possible_sequences=();
			}
		$seq_id=-1;
		foreach$reverse_primer(@reverse_primers_04)
			{
			$seq_id++;
			$sequence_id="r".$seq_id;
			$sequence=$reverse_primer;
			regenerate();
			print TEMP @possible_sequences;
			@possible_sequences=();
			}
		close TEMP;
		$progress_text.="\n Launching SeqMap: ";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		$reference_file=$reference_file_name;
		start_seqmap();
		$NM=1;
		$first_iteration_done=0;
		push(@seqmap_out,"r-1\tNM\t \n");
		foreach(@seqmap_out)
			{
			$f_or_r=substr($_,0,1);
			$seq_id=substr($_,1);
			$seq_id=~s/\t.+\n$//;
			if($first_iteration_done==1)
				{
				if($old_seq_id!=$seq_id&&$NM==1&&$f_or_r eq "f")
					{
					push(@forward_primers_05,$forward_primers_04[$old_seq_id]);
					push(@forward_primers_choordinates_05,$forward_primers_choordinates_04[$old_seq_id]);
					push(@ambiguities_forward_05,$ambiguities_forward_04[$old_seq_id]);
					push(@Tms_forward_05,$Tms_forward_04[$old_seq_id]);
					push(@GC_forward_05,$GC_forward_04[$old_seq_id]);
					}
				elsif($old_seq_id!=$seq_id&&$NM==1&&$f_or_r eq "r"&&$reverse_primers_04[$old_seq_id])
					{
					push(@reverse_primers_05,$reverse_primers_04[$old_seq_id]);
					push(@reverse_primers_choordinates_05,$reverse_primers_choordinates_04[$old_seq_id]);
					push(@ambiguities_reverse_05,$ambiguities_reverse_04[$old_seq_id]);
					push(@Tms_reverse_05,$Tms_reverse_04[$old_seq_id]);
					push(@GC_reverse_05,$GC_reverse_04[$old_seq_id]);
					}
				if($old_seq_id!=$seq_id)
					{
					$NM=1;
					}
				}
			
			unless($_=~/\tNM\t/)
				{
				$NM=0;
				}
			if($allow_one_match_in_reference==1)
				{
				if($_=~/\tU[012345]\t/)
					{
					$NM=1;
					}
				}
			
			$old_seq_id=$seq_id;
			$first_iteration_done=1;
			}
		$forward_primers_repeat=@forward_primers_05;
		$reverse_primers_repeat=@reverse_primers_05;
		$progress_text.=" done.\n\n (forward: $forward_primers_repeat / reverse: $reverse_primers_repeat)\n\n";
		$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
		}
	else
		{
		@forward_primers_05=@forward_primers_04;
		@ambiguities_forward_05=@ambiguities_forward_04;
		@forward_primers_choordinates_05=@forward_primers_choordinates_04;
		@Tms_forward_05=@Tms_forward_04;
		@GC_forward_05=@GC_forward_04;
		@reverse_primers_05=@reverse_primers_04;
		@ambiguities_reverse_05=@ambiguities_reverse_04;
		@reverse_primers_choordinates_05=@reverse_primers_choordinates_04;
		@Tms_reverse_05=@Tms_reverse_04;
		@GC_reverse_05=@GC_reverse_04;
		}
	if($given_forward_primer&&$forward_primers_repeat==0)
		{
		$start_smartprime->messageBox(-message=>"Defined forward primer matches to reference!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}
	if($given_reverse_primer&&$reverse_primers_repeat==0)
		{
		$start_smartprime->messageBox(-message=>"Defined reverse primer matches to reference!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}

	###   REJECTING MULTI-MATCHING PRIMERS   ###
	$progress_text.=" rejecting primers that match multiple to any sequence of the alignment... ";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	$primer_id=-1;
	foreach$forward_primer(@forward_primers_05)
		{
		$length_forward_primer=length$forward_primer;
		$original_forward_primer=$forward_primer;
		$primer_id++;
		$multi_hit_status=0;
		$forward_primer_rc=$forward_primer;
		$forward_primer_rc=reverse$forward_primer_rc;
		$forward_primer_rc=~tr/ACGTRYKMBDHV/TGCAYRMKVHDB/;
		@forward_primer=split('',$forward_primer);
		@forward_primer_rc=split('',$forward_primer_rc);
		foreach$position(@forward_primer)
			{
			degenerate();
			}
		$forward_primer=join('',@forward_primer);
		foreach$position(@forward_primer_rc)
			{
			degenerate();
			}
		$forward_primer_rc=join('',@forward_primer_rc);
		@sequences_copy=@sequences;
		foreach$original_sequence(@sequences_copy)
			{
			if($original_sequence=~/$forward_primer/)
				{
				$sequence1=$original_sequence;
				$sequence1=~s/^.*$forward_primer//i;
				$sequence2=$original_sequence;
				$sequence2=~s/$forward_primer.*$//i;
				$new_length=((length$sequence1)+(length$sequence2)+$length_forward_primer);
				if($length!=$new_length)
					{
					$multi_hit_status=1;
					}
				elsif($original_sequence=~/$forward_primer_rc/i)
					{
					$multi_hit_status=1;
					}
				}
			}
		unless($multi_hit_status==1)
			{
			push(@forward_primers_06,$original_forward_primer);
			push(@forward_primers_choordinates_06,$forward_primers_choordinates_05[$primer_id]);
			push(@ambiguities_forward_06,$ambiguities_forward_05[$primer_id]);
			push(@Tms_forward_06,$Tms_forward_05[$primer_id]);
			push(@GC_forward_06,$GC_forward_05[$primer_id]);
			}
		}
	$primer_id=-1;
	foreach$reverse_primer(@reverse_primers_05)
		{
		$length_reverse_primer=length$reverse_primer;
		$original_reverse_primer=$reverse_primer;
		$primer_id++;
		$multi_hit_status=0;
		$reverse_primer_rc=$reverse_primer;
		$reverse_primer_rc=reverse$reverse_primer;
		$reverse_primer_rc=~tr/ACGTRYKMBDHV/TGCAYRMKVHDB/;
		@reverse_primer=split('',$reverse_primer);
		@reverse_primer_rc=split('',$reverse_primer_rc);
		foreach$position(@reverse_primer)
			{
			degenerate();
			}
		$reverse_primer=join('',@reverse_primer);
		foreach$position(@reverse_primer_rc)
			{
			degenerate();
			}
		$reverse_primer_rc=join('',@reverse_primer_rc);
		@sequences_copy=@sequences;
		foreach$original_sequence(@sequences_copy)
			{
			if($original_sequence=~/$reverse_primer_rc/)
				{
				$sequence1=$original_sequence;
				$sequence1=~s/^.*$reverse_primer_rc//i;
				$sequence2=$original_sequence;
				$sequence2=~s/$reverse_primer_rc.*$//i;
				$new_length=((length$sequence1)+(length$sequence2)+$length_reverse_primer);
				if($length!=$new_length)
					{
					$multi_hit_status=1;
					}
				elsif($original_sequence=~/$reverse_primer/i)
					{
					$multi_hit_status=1;
					}
				}
			}
		unless($multi_hit_status==1)
			{
			push(@reverse_primers_06,$original_reverse_primer);
			push(@reverse_primers_choordinates_06,$reverse_primers_choordinates_05[$primer_id]);
			push(@ambiguities_reverse_06,$ambiguities_reverse_05[$primer_id]);
			push(@Tms_reverse_06,$Tms_reverse_05[$primer_id]);
			push(@GC_reverse_06,$GC_reverse_05[$primer_id]);
			}
		}
	$forward_primers_multi=@forward_primers_06;
	$reverse_primers_multi=@reverse_primers_06;
	$progress_text.="done.\n (forward: $forward_primers_multi / reverse: $reverse_primers_multi)\n\n\n";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	if($given_forward_primer&&$forward_primers_repeat==0)
		{
		$start_smartprime->messageBox(-message=>"Defined forward primer matches multiple to one or more sequences in the alignment!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}
	if($given_reverse_primer&&$reverse_primers_repeat==0)
		{
		$start_smartprime->messageBox(-message=>"Defined reverse primer matches multiple to one or more sequences in the alignment!",-type=>'ok',-icon=>'error');
		$progress_label->destroy;$start_smartprime->destroy;$progress_pane->destroy;
		}

	###   SORT PRIMERS BY QUALITY (AMBIGUITY-FACTOR -> OPTIMAL Tm -> DISTANCE TO TARGET -> OPTIMAL SIZE)   ###
	$progress_text.=" assembling proper primer pairs... ";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	$primer_id=-1;
	foreach$forward_primer(@forward_primers_06)
		{
		$primer_id++;
		$ambiguity_factor=$ambiguities_forward_06[$primer_id];
		$ambiguity_factor="00000".$ambiguity_factor;
		$ambiguity_factor=substr($ambiguity_factor,-6);
		$target_distance=$forward_primers_choordinates_06[$primer_id];
		$target_distance=~s/-.*$//;
		$target_distance=99999-$target_distance;
		$target_distance="00000".$target_distance;
		$target_distance=substr($target_distance,-6);
		$Tm=$Tms_forward_06[$primer_id];
		if($Tm=~/-/)
			{
			$Tm_high=$Tm;
			$Tm_high=~s/^.*-//;
			$Tm_low=$Tm;
			$Tm_low=~s/-.*$//;
			$Tm=($Tm_high+$Tm_low)/2;
			}
		$delta_T=abs($optimum_Tm-$Tm);
		############## formatting delta Tm to nn.nnnn #############
		unless($delta_T==0)
			{
			$before_decimal_point=$delta_T;
			$before_decimal_point=~s/\.\d+$//;	
			$after_decimal_point=$delta_T-$before_decimal_point;
			$after_decimal_point=~s/0//;
			$after_decimal_point=$after_decimal_point."000";
			$after_decimal_point=substr($after_decimal_point,0,5);
			if($before_decimal_point<10)
				{
				$before_decimal_point="0".$before_decimal_point;
				}
			$delta_T="$before_decimal_point$after_decimal_point";
			}
		else
			{
			$delta_T="00.0000";
			}
		#############################################
		$size=$forward_primer;
		$size=length$forward_primer;
		$delta_size=abs($optimum_primer_length-$size);
		$delta_size="000".$delta_size;
		$delta_size=substr($delta_size,-3);
		$all_datas="$ambiguity_factor $delta_T $target_distance $delta_size\t$forward_primer amb $ambiguities_forward_06[$primer_id] cho $forward_primers_choordinates_06[$primer_id] tm $Tms_forward_06[$primer_id] gc $GC_forward_06[$primer_id]";
		push(@all_datas_forward,$all_datas);
		@all_datas_forward_sorted=sort{lc($a) cmp lc($b)}@all_datas_forward;
		}
	$primer_id=-1;
	foreach$reverse_primer(@reverse_primers_06)
		{
		$primer_id++;
		$ambiguity_factor=$ambiguities_reverse_06[$primer_id];
		$ambiguity_factor="00000".$ambiguity_factor;
		$ambiguity_factor=substr($ambiguity_factor,-6);
		$target_distance=$reverse_primers_choordinates_06[$primer_id];
		$target_distance=~s/-.*$//;
		$target_distance="00000".$target_distance;
		$target_distance=substr($target_distance,-6);
		$Tm=$Tms_reverse_06[$primer_id];
		if($Tm=~/-/)
			{
			$Tm_high=$Tm;
			$Tm_high=~s/^.*-//;
			$Tm_low=$Tm;
			$Tm_low=~s/-.*$//;
			$Tm=($Tm_high+$Tm_low)/2;
			}
		$delta_T=abs($optimum_Tm-$Tm);
		############## formatting delta Tm to nn.nnnn #############
		unless($delta_T==0)
			{
			$before_decimal_point=$delta_T;
			$before_decimal_point=~s/\.\d+$//;	
			$after_decimal_point=$delta_T-$before_decimal_point;
			$after_decimal_point=~s/0//;
			$after_decimal_point=$after_decimal_point."000";
			$after_decimal_point=substr($after_decimal_point,0,5);
			if($before_decimal_point<10)
				{
				$before_decimal_point="0".$before_decimal_point;
				}
			$delta_T="$before_decimal_point$after_decimal_point";
			}
		else
			{
			$delta_T="00.0000";
			}
		#############################################
		$size=$reverse_primer;
		$size=length$reverse_primer;
		$delta_size=abs($optimum_primer_length-$size);
		$delta_size="000".$delta_size;
		$delta_size=substr($delta_size,-3);
		$all_datas="$ambiguity_factor $delta_T $target_distance $delta_size\t$reverse_primer amb $ambiguities_reverse_06[$primer_id] cho $reverse_primers_choordinates_06[$primer_id] tm $Tms_reverse_06[$primer_id] gc $GC_reverse_06[$primer_id]";
		push(@all_datas_reverse,$all_datas);
		@all_datas_reverse_sorted=sort{lc($a) cmp lc($b)}@all_datas_reverse;
		}
	primer_pair_search();

	###   SELECT N BEST PRIMERS   ###
	sub primer_pair_search
	{
	foreach(1..$best_left_right)
		{
		$top_rated_forward=shift@all_datas_forward_sorted;
		$top_rated_reverse=shift@all_datas_reverse_sorted;
		if($top_rated_forward)
			{
			push(@top_datas_forward_sorted,$top_rated_forward);
			}
		if($top_rated_reverse)
			{
			push(@top_datas_reverse_sorted,$top_rated_reverse);
			}
		}
	
	###   SEARCH POSSIBLE PRIMER PAIRS   ###
	@proper_primer_pairs=();
	$count_proper_primer_pairs=0;
	foreach$forward_data(@top_datas_forward_sorted)
		{
		$forward_primer=$forward_data;
		$forward_primer=~s/^.+\t//;
		$forward_primer=~s/ amb .+$//;	
		$forward_tm_high=$forward_data;
		$forward_tm_high=~s/^.+ tm [^-]+-//;
		$forward_tm_high=~s/ .+$//;
		$forward_tm_low=$forward_data;
		$forward_tm_low=~s/^.+ tm //;
		$forward_tm_low=~s/-.+$//;
		$forward_tm_low=~s/ .+$//;
		$forward_start_choordinate=$forward_data;
		$forward_start_choordinate=~s/^.+ cho //;
		$forward_start_choordinate=~s/-.+$//;
		$forward_end_choordinate=$forward_data;
		$forward_end_choordinate=~s/^.+ cho \d+-//;
		$forward_end_choordinate=~s/ .+$//;
		$forward_ambiguity=$forward_data;
		$forward_ambiguity=~s/^.+ amb //;
		$forward_ambiguity=~s/ cho .+$//;
		$forward_GC=$forward_data;
		$forward_GC=~s/^.+ gc //;
		foreach$reverse_data(@top_datas_reverse_sorted)
			{
			$reverse_primer=$reverse_data;
			$reverse_primer=~s/^.+\t//;
			$reverse_primer=~s/ amb .+$//;
			$reverse_tm_high=$reverse_data;
			$reverse_tm_high=~s/^.+ tm [^-]+-//;
			$reverse_tm_high=~s/ .+$//;
			$reverse_tm_low=$reverse_data;
			$reverse_tm_low=~s/^.+ tm //;
			$reverse_tm_low=~s/-.+$//;
			$reverse_tm_low=~s/ .+$//;
			$reverse_start_choordinate=$reverse_data;
			$reverse_start_choordinate=~s/^.+ cho //;
			$reverse_start_choordinate=~s/-.+$//;
			$reverse_end_choordinate=$reverse_data;
			$reverse_end_choordinate=~s/^.+ cho \d+-//;
			$reverse_end_choordinate=~s/ .+$//;
			$reverse_ambiguity=$reverse_data;
			$reverse_ambiguity=~s/^.+ amb //;
			$reverse_ambiguity=~s/ cho .+$//;
			$reverse_GC=$reverse_data;
			$reverse_GC=~s/^.+ gc //;
			if(abs($forward_tm_low-$reverse_tm_high)<$maximum_delta_Tm && abs($forward_tm_high-$reverse_tm_low)<$maximum_delta_Tm)
				{
				if(($reverse_end_choordinate+1)-$forward_start_choordinate<$maximum_product_size)
					{
					@complementarity_scores=();
					@primers_a=();
					@primers_b=();
					$primer_a=$forward_primer;
					$primer_b=$reverse_primer;
					$primer_b=reverse$primer_b;
					$primer_b=~tr/ACGTRYKMBDHV/TGCAYRMKVHDB/;
					$length_primer_a=length$primer_a;
					$length_primer_b=length$primer_b;
					push(@primers_a,$primer_a);
					push(@primers_b,$primer_b);
					$gap_position=0;
					foreach(0..$length_primer_b-2)
						{
						$gap_position++;
						$before_gap=substr($primer_b,0,$gap_position);
						$after_gap=substr($primer_b,$_+1);
						$gapped_primer="$before_gap"."-"."$after_gap";
						push(@primers_b,$gapped_primer);
						}
					do_comparisons();
					$gap_position=0;
					foreach(0..$length_primer_a-2)
						{
						$gap_position++;
						$before_gap=substr($primer_a,0,$gap_position);
						$after_gap=substr($primer_a,$_+1);
						$gapped_primer="$before_gap"."-"."$after_gap";
						push(@primers_a,$gapped_primer);
						}
					shift@primers_a;
					@primers_b=("$primer_b");
					do_comparisons();
					@sorted_complementarity_scores=sort{$b<=>$a}@complementarity_scores;
					$highest_score=shift@sorted_complementarity_scores;
					unless($highest_score>$maximum_3'_complementarity)
						{
						$count_proper_primer_pairs++;
						$pair_ambiguity=$forward_ambiguity+$reverse_ambiguity;
						$pair_ambiguity="00000".$pair_ambiguity;
						$pair_ambiguity=substr($pair_ambiguity,-6);
						@pair_Tm=($forward_tm_high,$forward_tm_low,$reverse_tm_high,$reverse_tm_low);
						@pair_Tm_sortet=sort{$a<=>$b}@pair_Tm;
						$pair_delta_Tm=abs($pair_Tm_sortet[0]-$pair_Tm_sortet[3]);
						############# formatting pair delta Tm to nn.nnnn ############
						unless($pair_delta_Tm==0)
							{
							$before_decimal_point=$pair_delta_Tm;
							$before_decimal_point=~s/\.\d+$//;	
							$after_decimal_point=$pair_delta_Tm-$before_decimal_point;
							$after_decimal_point=~s/0//;
							$after_decimal_point=$after_decimal_point."000";
							$after_decimal_point=substr($after_decimal_point,0,5);
							if($before_decimal_point<10)
								{
								$before_decimal_point="0".$before_decimal_point;
								}
							$pair_delta_Tm="$before_decimal_point$after_decimal_point";
							}					
						else
							{
							$pair_delta_Tm="00.0000";
							}
						#############################################
						$pair_product_size=($reverse_end_choordinate+1)-$forward_start_choordinate;
						$pair_product_size="00000".$pair_product_size;
						$pair_product_size=substr($pair_product_size,-6);
						push(@proper_primer_pairs,"$pair_ambiguity $pair_delta_Tm $pair_product_size\t\t$forward_data\t\t$reverse_data");
						}
					}
				}
			}
		}
	}

	###   REPEAT SEARCH IF N POSSIBLE PRIMERPAIRS TO SMALL   ###
	if($count_proper_primer_pairs<$minimum_primer_pair_output)
		{
		if(@all_datas_forward_sorted || @all_datas_reverse_sorted)
			{
			primer_pair_search();
			}
		}
	$progress_text.="done. Found $count_proper_primer_pairs proper primer pairs.\n\n\n";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	###   OUTPUT TOP-RATED PRIMER PAIRS   ###
	@sorted_proper_primer_pairs=sort{lc($a) cmp lc($b)}@proper_primer_pairs;
	open(OUTPUT,">easyPAC_text_temp");
	unless($forward_primers_repeat)
		{
		$forward_primers_repeat=$forward_primers_selfcomplement;
		$reverse_primers_repeat=$reverse_primers_selfcomplement;
		}
	print OUTPUT "Considered forward primers: $all_considered_forward_primer\nAfter filtering out unproper ambiguity and target distance: $forward_primers_proper_abiguity\nAfter rejecting unproper GC-content and Tm: $forward_primers_proper_GC_Tm\nAfter rejecting to much poly-X/XY: $forward_primers_polyXY\nAfter rejecting primers with too high 3'-end stability: $forward_primers_stability\nAfter rejecting primers with too high 3'-selfcomplementarity score: $forward_primers_selfcomplement\nAfter rejecting reference-matching primers: $forward_primers_repeat\nAfter rejecting multiple matching primers: $forward_primers_multi\n\n";
	print OUTPUT "Considered reverse primers: $all_considered_reverse_primer\nAfter filtering out unproper ambiguity and target distance: $reverse_primers_proper_abiguity\nAfter rejecting unproper GC-content and Tm: $reverse_primers_proper_GC_Tm\nAfter rejecting to much poly-X/XY: $reverse_primers_polyXY\nAfter rejecting primers with too high 3'-end stability: $reverse_primers_stability\nAfter rejecting primers with too high 3'-selfcomplementarity score: $reverse_primers_selfcomplement\nAfter rejecting reference-matching primers: $reverse_primers_repeat\nAfter rejecting multiple matching primers: $reverse_primers_multi\n\n";
	print OUTPUT "Alignment:\n";
	$seq_id=-1;
	foreach(@titles)
		{
		$seq_id++;
		$_=~s/>//;
		$title=$_.":"."                    ";
		$title=substr($title,0,20);
		print OUTPUT "$title $sequences[$seq_id]\n";
		}
	print OUTPUT "CONSENSUS:           $consensus\n\n\n";
	$add_spaces=$maximum_primer_length;	
	print OUTPUT "PRIMER PAIR"." "x$add_spaces."   size      coordinates      Tm[C]          %GC             ambiguity factor\n\n";
	$number_pairs=0;
	foreach(@sorted_proper_primer_pairs)
		{
		$number_pairs++;
		$forward_primer=$_;
		$forward_primer=~s/^[^\t]+\t\t[^\t]+\t//;
		$forward_primer=~s/ amb .+$//;
		$forward_primer_size=length$forward_primer;
		$forward_primer=$forward_primer."                                                  ";
		$forward_primer=substr($forward_primer,0,$maximum_primer_length+1);
		$forward_choordinates=$_;
		$forward_choordinates=~s/^[^\t]+\t\t[^\t]+\t[^\t]+ cho //;
		$forward_choordinates=~s/ tm .+$//;
		@forward_start_and_end=split('-',$forward_choordinates);
		$forward_start=$forward_start_and_end[0]+1;
		$forward_start=$forward_start."      ";
		$forward_start=substr($forward_start,0,6);
		$forward_end=$forward_start_and_end[1]+1;
		$forward_end=$forward_end."      ";
		$forward_end=substr($forward_end,0,6);
		$forward_Tm=$_;
		$forward_Tm=~s/^[^\t]+\t\t[^\t]+\t[^\t]+ tm //;
		$forward_Tm=~s/ gc .+$//;
		if($forward_Tm=~/-/)
			{
			@low_high_Tm=split('-',$forward_Tm);
			if($low_high_Tm[0]==$low_high_Tm[1])
				{
				$forward_Tm=~s/-.+$//;
				$forward_Tm=substr($forward_Tm,0,5);
				$forward_Tm=$forward_Tm."             ";
				$forward_Tm=substr($forward_Tm,0,13);
				}
			else
				{
				$low_high_Tm[0]=$low_high_Tm[0]."     ";
				$low_high_Tm[0]=substr($low_high_Tm[0],0,5);
				$low_high_Tm[1]=$low_high_Tm[1]."     ";
				$low_high_Tm[1]=substr($low_high_Tm[1],0,5);
				$forward_Tm=$low_high_Tm[0]." - ".$low_high_Tm[1];
				}
			}
		$forward_GC=$_;
		$forward_GC=~s/^[^\t]+\t\t[^\t]+\t[^\t]+ gc //;
		$forward_GC=~s/\t\t.+$//;
		if($forward_GC=~/-/)
			{
			@low_high_GC=split('-',$forward_GC);
			$low_high_GC[0]=$low_high_GC[0]."     ";
			$low_high_GC[0]=substr($low_high_GC[0],0,5);
			$low_high_GC[1]=$low_high_GC[1]."     ";
			$low_high_GC[1]=substr($low_high_GC[1],0,5);
			$forward_GC=$low_high_GC[0]." - ".$low_high_GC[1];
			}
		else
			{
			$forward_GC=substr($forward_GC,0,5);
			$forward_GC=$forward_GC."             ";
			$forward_GC=substr($forward_GC,0,13);
			}
		$forward_ambiguity=$_;
		$forward_ambiguity=~s/^[^\t]+\t\t[^\t]+\t[^\t]+ amb //;
		$forward_ambiguity=~s/ cho .+$//;
		$forward_ambiguity=$forward_ambiguity."  ";
		$forward_ambiguity=substr($forward_ambiguity,0,3);
		$reverse_primer=$_;
		$reverse_primer=~s/^[^\t]+\t\t[^\t]+\t[^\t]+\t\t[^\t]+\t//;
		$reverse_primer=~s/ amb .+$//;
		$reverse_primer_rc=$reverse_primer;
		$reverse_primer_rc=reverse$reverse_primer_rc;
		$reverse_primer_rc=~tr/ACGTRYKMBDHVacgtryswkmbdhv/TGCAYRMKVHDBtgcayrwsmkvhdb/;
		$reverse_primer_size=length$reverse_primer;
		$reverse_primer=$reverse_primer."                                                  ";
		$reverse_primer=substr($reverse_primer,0,$maximum_primer_length+1);
		$reverse_primer_rc="(".$reverse_primer_rc.")"."                                                  ";
		$reverse_primer_rc=substr($reverse_primer_rc,0,$maximum_primer_length+1);
		$reverse_choordinates=$_;
		$reverse_choordinates=~s/^[^\t]+\t\t[^\t]+\t[^\t]+\t\t[^\t]+\t[^\t]+ cho //;
		$reverse_choordinates=~s/ tm .+$//;
		@reverse_start_and_end=split('-',$reverse_choordinates);
		$reverse_start=$reverse_start_and_end[0]+1;
		$reverse_start=$reverse_start."      ";
		$reverse_start=substr($reverse_start,0,6);
		$reverse_end=$reverse_start_and_end[1]+1;
		$reverse_end=$reverse_end."      ";
		$reverse_end=substr($reverse_end,0,6);
		$reverse_Tm=$_;
		$reverse_Tm=~s/^[^\t]+\t\t[^\t]+\t[^\t]+\t\t[^\t]+\t[^\t]+ tm //;
		$reverse_Tm=~s/ gc .+$//;
		if($reverse_Tm=~/-/)
			{
			@low_high_Tm=split('-',$reverse_Tm);
			if($low_high_Tm[0]==$low_high_Tm[1])
				{
				$reverse_Tm=~s/-.+$//;
				$reverse_Tm=substr($reverse_Tm,0,5);
				$reverse_Tm=$reverse_Tm."             ";
				$reverse_Tm=substr($reverse_Tm,0,13);
				}
			else
				{
				$low_high_Tm[0]=$low_high_Tm[0]."     ";
				$low_high_Tm[0]=substr($low_high_Tm[0],0,5);
				$low_high_Tm[1]=$low_high_Tm[1]."     ";
				$low_high_Tm[1]=substr($low_high_Tm[1],0,5);
				$reverse_Tm=$low_high_Tm[0]." - ".$low_high_Tm[1];
				}
			}
		$reverse_GC=$_;
		$reverse_GC=~s/^[^\t]+\t\t[^\t]+\t[^\t]+\t\t[^\t]+\t[^\t]+ gc //;
		$reverse_GC=~s/\t\t.+$//;
		if($reverse_GC=~/-/)
			{
			@low_high_GC=split('-',$reverse_GC);
			$low_high_GC[0]=$low_high_GC[0]."     ";
			$low_high_GC[0]=substr($low_high_GC[0],0,5);
			$low_high_GC[1]=$low_high_GC[1]."     ";
			$low_high_GC[1]=substr($low_high_GC[1],0,5);
			$reverse_GC=$low_high_GC[0]." - ".$low_high_GC[1];
			}
		else
			{
			$reverse_GC=substr($reverse_GC,0,5);
			$reverse_GC=$reverse_GC."             ";
			$reverse_GC=substr($reverse_GC,0,13);
			}
		$reverse_ambiguity=$_;
		$reverse_ambiguity=~s/^[^\t]+\t\t[^\t]+\t[^\t]+\t\t[^\t]+\t[^\t]+ amb //;
		$reverse_ambiguity=~s/ cho .+$//;
		$reverse_ambiguity=$reverse_ambiguity."  ";
		$reverse_ambiguity=substr($reverse_ambiguity,0,3);
		$product_size=$_;
		$product_size=~s/\t\t.+$//;
		$product_size=reverse$product_size;
		$product_size=~s/\ .+$//;
		$product_size=reverse$product_size;
		$product_size=0+$product_size;	
		print OUTPUT "#$number_pairs  -> product size: $product_size nt\n";
		print OUTPUT "forward:  $forward_primer   $forward_primer_size nt     $forward_start- $forward_end   $forward_Tm   $forward_GC   $forward_ambiguity\n";
		print OUTPUT "reverse:  $reverse_primer   $reverse_primer_size nt     $reverse_start- $reverse_end   $reverse_Tm   $reverse_GC   $reverse_ambiguity\n";
		print OUTPUT "         $reverse_primer_rc\n\n";
		if($number_pairs<=$primer_pairs_in_graphical_output)
			{
			$primer_color=$im->colorAllocate(162,205,90);
			$sequence_hight=$sequence_hight+20;
			$im->string(gdSmallFont,5,$sequence_hight,"Primer Pair #$number_pairs",$black);
			$letter_position=($forward_start*6)+92;
			$letter_position2=(($forward_end+1)*6)+94;
			foreach(0..14)
				{
				$im->line($letter_position,$sequence_hight+$_,$letter_position2,$sequence_hight+$_,$primer_color);
				}
			$letter_position=$letter_position-10;
			$forward_primer=~s/ //g;
			$im->string(gdSmallFont,$letter_position,$sequence_hight,"> $forward_primer >",$black);
			$primer_color=$im->colorAllocate(100,170,255);
			$letter_position=($reverse_start*6)+92;
			$letter_position2=(($reverse_end+1)*6)+94;
			foreach(0..14)
				{
				$im->line($letter_position,$sequence_hight+$_,$letter_position2,$sequence_hight+$_,$primer_color);
				}
			$letter_position=$letter_position-10;
			$reverse_primer=~s/ //g;
			$im->string(gdSmallFont,$letter_position,$sequence_hight,"< $reverse_primer <",$black);
			}
		}
	close OUTPUT;

	###   MAKE GRAPHIC FILE   ###
	open (GD,">easyPAC_image_temp");
	binmode GD;
	print GD $im->png;
	close GD;
	
	###   END   ###
	if($reference_file_name&&$reference_file_name eq"merged_references")
		{
		unlink "merged_references";
		}
	$computation_end=time;
	$computation_time=$computation_end-$computation_start;
	$hours=int($computation_time/3600);
	$minutes=int(($computation_time-$hours*3600)/60);
	$seconds=$computation_time-($hours*3600)-($minutes*60);
	$progress_text.=" Computation finished.\n Elapsed time: $hours hours, $minutes minutes, $seconds seconds.";
	$progress_label->configure(-text=>$progress_text);$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	$progress_text.="\n\n\n\n\n\n\n";
	$progress_label->configure(-text=>$progress_text,-cursor=>'arrow');$progress_label->update;$progress_pane->yview(moveto=>1);$progress_pane->update;
	$start_smartprime->configure(-title=>"Primer search finished");
	$white="";
	###   clean initialized arrays   ###
	clean_arrays();
	sub clean_arrays
		{
		@sequences=();
		@titles=();
		@rep_sequences=();
		@rep_titles=();
		@conditions=();
		@sequence_annotation=();
		@forward_primers_choordinates_00=();@forward_primers_choordinates_01=();@forward_primers_choordinates_02=();@forward_primers_choordinates_03=();@forward_primers_choordinates_04=();@forward_primers_choordinates_05=();@forward_primers_choordinates_06=();
		@reverse_primers_choordinates_00=();@reverse_primers_choordinates_01=();@reverse_primers_choordinates_02=();@reverse_primers_choordinates_03=();@reverse_primers_choordinates_04=();@reverse_primers_choordinates_05=();@reverse_primers_choordinates_06=();
		@ambiguities_forward_00=();@ambiguities_forward_01=();@ambiguities_forward_02=();@ambiguities_forward_03=();@ambiguities_forward_04=();@ambiguities_forward_05=();@ambiguities_forward_06=();
		@ambiguities_reverse_00=();@ambiguities_reverse_01=();@ambiguities_reverse_02=();@ambiguities_reverse_03=();@ambiguities_reverse_04=();@ambiguities_reverse_05=();@ambiguities_reverse_06=();
		@forward_primers_00=();@forward_primers_01=();@forward_primers_02=();@forward_primers_03=();@forward_primers_04=();@forward_primers_05=();@forward_primers_06=();
		@reverse_primers_00=();@reverse_primers_01=();@reverse_primers_02=();@reverse_primers_03=();@reverse_primers_04=();@reverse_primers_05=();@reverse_primers_06=();
		@Tms_forward_01=();@Tms_forward_02=();@Tms_forward_03=();@Tms_forward_04=();@Tms_forward_05=();@Tms_forward_06=();
		@GC_forward_01=();@GC_forward_02=();@GC_forward_03=();@GC_forward_04=();@GC_forward_05=();@GC_forward_06=();
		@Tms_reverse_01=();@Tms_reverse_02=();@Tms_reverse_03=();@Tms_reverse_04=();@Tms_reverse_05=();@Tms_reverse_06=();
		@GC_reverse_01=();@GC_reverse_02=();@GC_reverse_03=();@GC_reverse_04=();@GC_reverse_05=();@GC_reverse_06=();
		@poly_XY=();
		@good_end_stability_forward_primer=();
		@good_end_stability_forward_choordinates=();
		@good_end_stability_forward_ambiguities=();
		@good_end_stability_forward_Tms=();
		@good_end_stability_forward_GC=();
		@good_end_stability_reverse_primer=();
		@good_end_stability_reverse_choordinates=();
		@good_end_stability_reverse_ambiguities=();
		@good_end_stability_reverse_Tms=();
		@good_end_stability_reverse_GC=();
		@all_datas_forward=();
		@all_datas_reverse=();
		@all_datas_forward_sorted=();
		@all_datas_reverse_sorted=();
		@top_datas_forward_sorted=();
		@top_datas_reverse_sorted=();	
		}
	$start_smartprime->Button(-width=>20,-text=>"OK",-command=>\&close_progress_window)->pack(-anchor=>'n',-pady=>20);
	
	###   SUBROUTINES   ###
	sub close_progress_window
		{
		$progress_label->destroy;
		$start_smartprime->destroy;
		open(RESULTS_TEXT,"easyPAC_text_temp");
		$results_text="";
		while(<RESULTS_TEXT>)
			{
			$results_text.=$_;
			}
		close RESULTS_TEXT;
		$results_image=$mw->Photo(-format=>'png',-file=>"easyPAC_image_temp");
		$results_picture_button->configure(-activebackground=>"cornsilk",-background=>"cornsilk",-state=>'normal');
		$results_text_button->configure(-activebackground=>"cornsilk",-background=>"cornsilk",-state=>'normal');
		$save_results_button->configure(-activebackground=>"cornsilk",-background=>"cornsilk",-state=>'normal');
		display_text;
		foreach(@buttons)
		{$_->configure(-state=>'normal');}
		}
	
	sub save_results
		{
		$save_ok=0;
		$folder_number=0;
		while($save_ok==0)
			{
			$folder_number++;
			if(!-e "easyPAC_results_$folder_number")
				{
				unless(mkdir("easyPAC_results_$folder_number"))
					{
					$mw->messageBox(-message=>"Error! Could not open folder to save files",-type=>'ok',-icon=>'error');
					$save_ok=-1;
					}
				else
					{
					rename("easyPAC_text_temp","easyPAC_results_$folder_number/easyPAC_results_text.txt");
					rename("easyPAC_image_temp","easyPAC_results_$folder_number/easyPAC_results_image.png");
					$save_ok=1;
					$mw->messageBox(-message=>"Results saved at easyPAC_results_$folder_number",-type=>'ok',-icon=>'info');
					$save_results_button->configure(-state=>'disabled');
					}
				}
			}
		}
	
	sub delete_temporary_files
		{
		if(-e "easyPAC_text_temp")
			{
			unlink"easyPAC_text_temp";
			}
		if(-e "easyPAC_image_temp")
			{
			unlink"easyPAC_image_temp";
			}
		if(-e "seqmap")
			{
			unlink"seqmap";
			}
		}

	sub Tm_nearest_neighbor # thermodynamics from Santa Lucia
		{
		$dH_aa_tt=-7.9;
		$dH_at_ta=-7.2;
		$dH_ta_at=-7.2;
		$dH_ca_gt=-8.5;
		$dH_gt_ca=-8.4;
		$dH_ct_ga=-7.8;
		$dH_ga_ct=-8.2;
		$dH_cg_gc=-10.6;
		$dH_gc_cg=-9.8;
		$dH_gg_cc=-8.0;
		$dH_init_term_GC=0.1;
		$dH_init_term_AT=2.3;
		$dS_aa_tt=-22.2;
		$dS_at_ta=-20.4;
		$dS_ta_at=-21.3;
		$dS_ca_gt=-22.7;
		$dS_gt_ca=-22.4;
		$dS_ct_ga=-21.0;
		$dS_ga_ct=-22.2;
		$dS_cg_gc=-27.2;
		$dS_gc_cg=-24.4;
		$dS_gg_cc=-19.9;
		$dS_init_term_GC=-2.8;
		$dS_init_term_AT=4.1;
		
		$length_primer=length$primer;
		$initial_base=substr($primer,0,1);
		$terminal_base=substr($primer,-1);
		# Tm high #	
		if($initial_base=~/[GCRYSKMBDHVN]/i)
			{
			$dH_initial_base=$dH_init_term_GC;
			$dS_initial_base=$dS_init_term_GC;
			}
		else
			{
			$dH_initial_base=$dH_init_term_AT;
			$dS_initial_base=$dS_init_term_AT;
			}
		if($terminal_base=~/[GCRYSKMBDHVN]/i)
			{
			$dH_terminal_base=$dH_init_term_GC;
			$dS_terminal_base=$dS_init_term_GC;
			}
		else
			{
			$dH_terminal_base=$dH_init_term_AT;
			$dS_terminal_base=$dS_init_term_AT;
			}
		$sum_dH=0;
		$sum_dS=0;
		foreach(0..$length_primer-2)
			{
			$pair=substr($primer,$_,2);
			if($pair=~/[GRSKBDVN][GRSKBDVN]/i || $pair=~/[CYSMBHVN][CYSMBHVN]/i)
				{
				$sum_dH=$sum_dH+$dH_gg_cc;
				$sum_dS=$sum_dS+$dS_gg_cc;
				}
			elsif($pair=~/[GRSKBDVN][CYSMBHVN]/i)
				{
				$sum_dH=$sum_dH+$dH_gc_cg;
				$sum_dS=$sum_dS+$dS_gc_cg;
				}
			elsif($pair=~/[CYSMBHVN][GRSKBDVN]/i)
				{
				$sum_dH=$sum_dH+$dH_cg_gc;
				$sum_dS=$sum_dS+$dS_cg_gc;
				}
			elsif($pair=~/[GRSKBDVN][TW]/i || $pair=~/[AW][CYSMBHVN]/i)
				{
				$sum_dH=$sum_dH+$dH_gt_ca;
				$sum_dS=$sum_dS+$dS_gt_ca;
				}
			elsif($pair=~/[CYSMBHVN][AW]/i || $pair=~/[TW][GRSKBDVN]/i)
				{
				$sum_dH=$sum_dH+$dH_ca_gt;
				$sum_dS=$sum_dS+$dS_ca_gt;
				}
			elsif($pair=~/[CYSMBHVN][TW]/i || $pair=~/[AW][GRSKBDVN]/i)
				{
				$sum_dH=$sum_dH+$dH_ct_ga;
				$sum_dS=$sum_dS+$dS_ct_ga;
				}
			elsif($pair=~/[GRSKBDVN][AW]/i || $pair=~/[TW][CYSMBHVN]/i)
				{
				$sum_dH=$sum_dH+$dH_ga_ct;
				$sum_dS=$sum_dS+$dS_ga_ct;
				}
			elsif($pair=~/[AW][AW]/i || $pair=~/[TW][TW]/i)
				{
				$sum_dH=$sum_dH+$dH_aa_tt;
				$sum_dS=$sum_dS+$dS_aa_tt;
				}
			elsif($pair=~/[AW][TW]/i)
				{
				$sum_dH=$sum_dH+$dH_at_ta;
				$sum_dS=$sum_dS+$dS_at_ta;
				}
			elsif($pair=~/[TW][AW]/i)
				{
				$sum_dH=$sum_dH+$dH_ta_at;
				$sum_dS=$sum_dS+$dS_ta_at;
				}
			}
		$salt_effect=($Na_concentration+($Mg_concentration*140));
		$salt_correction=0.368*((length$primer)-1)*log($salt_effect);
		$Tm_maximum=((($sum_dH+$dH_initial_base+$dH_terminal_base)*1000)/(($sum_dS+$dS_initial_base+$dS_terminal_base+$salt_correction-1.4)+(1.987*log($primer_concentration/2000000000))))-273.15;
		# Tm low #
		if($initial_base=~/[GCS]/i)
			{
			$dH_initial_base=$dH_init_term_GC;
			$dS_initial_base=$dS_init_term_GC;
			}
		else
			{
			$dH_initial_base=$dH_init_term_AT;
			$dS_initial_base=$dS_init_term_AT;
			}
		if($terminal_base=~/[GCS]/i)
			{
			$dH_terminal_base=$dH_init_term_GC;
			$dS_terminal_base=$dS_init_term_GC;
			}
		else
			{
			$dH_terminal_base=$dH_init_term_AT;
			$dS_terminal_base=$dS_init_term_AT;
			}
		$sum_dH=0;
		$sum_dS=0;
		foreach(0..$length_primer-2)
			{
			$pair=substr($primer,$_,2);
			if($pair=~/[TYWKBDHN][ARMDHVN]/i)
				{
				$sum_dH=$sum_dH+$dH_ta_at;
				$sum_dS=$sum_dS+$dS_ta_at;
				}
			elsif($pair=~/[ARMDHVN][TYWKBDHN]/i)
				{
				$sum_dH=$sum_dH+$dH_at_ta;
				$sum_dS=$sum_dS+$dS_at_ta;
				}
			elsif($pair=~/[ARMDHVN][ARMDHVN]/i || $pair=~/[TYWKBDHN][TYWKBDHN]/i)
				{
				$sum_dH=$sum_dH+$dH_aa_tt;
				$sum_dS=$sum_dS+$dS_aa_tt;
				}
			elsif($pair=~/[GS][ARMDHVN]/i || $pair=~/[TYWKBDHN][CS]/i)
				{
				$sum_dH=$sum_dH+$dH_ga_ct;
				$sum_dS=$sum_dS+$dS_ga_ct;
				}
			elsif($pair=~/[CS][TYWKBDHN]/i || $pair=~/[ARMDHVN][GS]/i)
				{
				$sum_dH=$sum_dH+$dH_ct_ga;
				$sum_dS=$sum_dS+$dS_ct_ga;
				}
			elsif($pair=~/[CS][ARMDHVN]/i || $pair=~/[TYWKBDHN][GS]/i)
				{
				$sum_dH=$sum_dH+$dH_ca_gt;
				$sum_dS=$sum_dS+$dS_ca_gt;
				}
			elsif($pair=~/[GS][TYWKBDHN]/i || $pair=~/[ARMDHVN][CS]/i)
				{
				$sum_dH=$sum_dH+$dH_gt_ca;
				$sum_dS=$sum_dS+$dS_gt_ca;
				}
			elsif($pair=~/[CS][GS]/i)
				{
				$sum_dH=$sum_dH+$dH_cg_gc;
				$sum_dS=$sum_dS+$dS_cg_gc;
				}
			elsif($pair=~/[GS][CS]/i)
				{
				$sum_dH=$sum_dH+$dH_gc_cg;
				$sum_dS=$sum_dS+$dS_gc_cg;
				}
			elsif($pair=~/[GS][GS]/i || $pair=~/[CS][CS]/i)
				{
				$sum_dH=$sum_dH+$dH_gg_cc;
				$sum_dS=$sum_dS+$dS_gg_cc;
				}
			}
		$salt_effect=($Na_concentration+($Mg_concentration*140));
		$salt_correction=0.368*((length$primer)-1)*log($salt_effect);
		$Tm_minimum=((($sum_dH+$dH_initial_base+$dH_terminal_base)*1000)/(($sum_dS+$dS_initial_base+$dS_terminal_base+$salt_correction-1.4)+(1.987*log($primer_concentration/2000000000))))-273.15;
		}

	sub end_stability
		{
		$dG_aa_tt=-1.00;
		$dG_at_ta=-0.88;
		$dG_ta_at=-0.58;
		$dG_ca_gt=-1.45;
		$dG_gt_ca=-1.44;
		$dG_ct_ga=-1.28;
		$dG_ga_ct=-1.30;
		$dG_cg_gc=-2.17;
		$dG_gc_cg=-2.24;
		$dG_gg_cc=-1.84;
		$dG_init_term_GC=0.98;
		$dG_init_term_AT=1.03;
		$sum_dG=0;
		$last_five_nucleotides=substr($primer,-5);
		$terminal_base=substr($primer,-1);
		if($terminal_base=~/[GCRYSKMBDHVN]/i)
			{
			$dG_terminal_base=$dG_init_term_GC;
			}
		else
			{
			$dG_terminal_base=$dG_init_term_AT;
			}
		foreach(0..3)
			{
			$pair=substr($last_five_nucleotides,$_,2);
			if($pair=~/[GRSKBDVN][GRSKBDVN]/i || $pair=~/[CYSMBHVN][CYSMBHVN]/i)
				{
				$sum_dG=$sum_dG+$dG_gg_cc;
				}
			elsif($pair=~/[GRSKBDVN][CYSMBHVN]/i)
				{
				$sum_dG=$sum_dG+$dG_gc_cg;
				}
			elsif($pair=~/[CYSMBHVN][GRSKBDVN]/i)
				{
				$sum_dG=$sum_dG+$dG_cg_gc;
				}
			elsif($pair=~/[GRSKBDVN][TW]/i || $pair=~/[AW][CYSMBHVN]/i)
				{
				$sum_dG=$sum_dG+$dG_gt_ca;
				}
			elsif($pair=~/[CYSMBHVN][AW]/i || $pair=~/[TW][GRSKBDVN]/i)
				{
				$sum_dG=$sum_dG+$dG_ca_gt;
				}
			elsif($pair=~/[CYSMBHVN][TW]/i || $pair=~/[AW][GRSKBDVN]/i)
				{
				$sum_dG=$sum_dG+$dG_ct_ga;
				}
			elsif($pair=~/[GRSKBDVN][AW]/i || $pair=~/[TW][CYSMBHVN]/i)
				{
				$sum_dG=$sum_dG+$dG_ga_ct;
				}
			elsif($pair=~/[AW][AW]/i || $pair=~/[TW][TW]/i)
				{
				$sum_dG=$sum_dG+$dG_aa_tt;
				}
			elsif($pair=~/[AW][TW]/i)
				{
				$sum_dG=$sum_dG+$dG_at_ta;
				}
			elsif($pair=~/[TW][AW]/i)
				{
				$sum_dG=$sum_dG+$dG_ta_at;
				}
			}
		$end_stability=$sum_dG+$dG_terminal_base;
		}

	sub degenerate
		{
		$changed=0;
		if($position=~s/A/[ARWMDHVN]/ig){$changed=1;}
		unless($changed==1){if($position=~s/T/[TYWKBDHN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/G/[GRSKBDVN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/C/[CYSMBHVN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/M/[MACRYSWVHBDN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/R/[RAGSWKMVHBDN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/W/[WATKMRYVHBDN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/S/[SCGRYKMVHBDN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/Y/[YCTSWKMVHBDN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/K/[KGTRYSWVHBDN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/V/[AGCMRWSYKVHDBN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/H/[ATCMRWSYKVHDBN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/D/[AGTMRWSYKVHDBN]/ig){$changed=1;}}
		unless($changed==1){if($position=~s/B/[GTCMRWSYKVHDBN]/ig){$changed=1;}}
		unless($changed==1){$position=~s/N/[AGTCMRWSYKVHDBN]/ig;}
		}

	sub regenerate
		{
		@sequence=split('',$sequence);
		@data=();
		foreach$_(@sequence)
			{
			if($_ eq "A"){push(@data,[qw / A /]);}
			elsif($_ eq "T"){push(@data,[qw / T /]);}
			elsif($_ eq "G"){push(@data,[qw / G /]);}
			elsif($_ eq "C"){push(@data,[qw / C /]);}
			elsif($_ eq "R"){push(@data,[qw / A G /]);}
			elsif($_ eq "Y"){push(@data,[qw / T C /]);}
			elsif($_ eq "S"){push(@data,[qw / C G /]);}
			elsif($_ eq "W"){push(@data,[qw / T A /]);}
			elsif($_ eq "K"){push(@data,[qw / T G /]);}
			elsif($_ eq "M"){push(@data,[qw / A C /]);}
			elsif($_ eq "B"){push(@data,[qw / T G C /]);}
			elsif($_ eq "D"){push(@data,[qw / T A G /]);}
			elsif($_ eq "H"){push(@data,[qw / T A C /]);}
			elsif($_ eq "V"){push(@data,[qw / A G C /]);}
			elsif($_ eq "N"){push(@data,[qw / A T G C /]);}
			}
		$iterator=Iterator::Array::Jagged->new(data=>\@data);
		while(@set=$iterator->next)
			{
			$possibility=">$sequence_id\n".join('',@set)."\n";
			push(@possible_sequences,$possibility);
			}
		}
		
	sub start_seqmap
		{
		system("seqmap $mismatch_seqmap in.temp $reference_file out.temp /allow_insdel:$insdel_seqmap /silent");
		open(SEQMAP_OUT,"out.temp");
		@seqmap_out=<SEQMAP_OUT>;
		close SEQMAP_OUT;
		unlink("out.temp");
		unlink("in.temp");
		}
	}

###   SAMPLE ALIGNMENT   ###
sub use_demo
	{
	$PCR_target_start=600;
	$PCR_target_end=1100;
	$excluded_regions_string="1200-1300";
	$input_paste->delete("1.0",'end');
	$sample_alignment="
		>Sequence_1 \n
		GACCTGCGGGCTGTGTGGCAACTTTAACATCTTTGCTGAAGATGACTTTCAGAGAGAGAG
		AGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGTGGGCTCTGAGCAGTGGAGA
		ACA-GTGGTGTGAACGGGCATCTCCTCCCAGCAGCTCATGCAACATCTCCTCTGGGGAAA
		TGCAGAAGGGCCTGTGGGAGCAAAAAAAAAAAAAAAAAAA-AAAAAAAAAAAAAAAAAAA
		AAAAAAAAAAAACCTGTGCCCAGGAGGGAAT-GGTGCTGTACGGCTGGACCGACCAC-AG
		CGCGTGAAACCCCGTCTCTACTAAAAATACAAAAAATTAGCCGGGCGTGGTGGCGGGCGC
		CTGTAGTCCCAGCTAC-TCGGGAGGCTGAGGCAG-GAGAATGGCGTTGCAGCCCAGTGTG
		CCCTGCTGGTATGGAGTATAGGCAGTGTGTGTCCCCTTGCGCCAGG-ACCTGCCAGAGCC
		TGCACATCAATGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGA-AGGCCTCTGCGTGGAGAGCACCGAGTGTCCCTGCGTGCATTCCGGA
		AAGCGCTACCCTCCCGGCACCTCCCT-CTCTCGAGACTGCAACACCTG-CATTTGCCGAA
		ACAGCCAGTGGATCTGCAGCAATGAAGAATGTCCAGGGGAGTGCCTTGTC-ACAGGTC-A
		ATCACACTTCAAGAGCTTTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		TGCTGGCCCGGGATTGCCAGGAC-CACTCCTTCTCCATTGTCATTGAGACTGTCCAGTGT
		-GCTGATGACCGCGACGCTGTGTGCACCCGCTCCGTCACCGTCC-GGCTGCCTGGCCTGC
		ACAACAGCCTTGTGAAACTGAAGCATGGGGCAGGAGTTGCCATGGA-TGGCCAGGACGTC
		CAGCTCCCCCTCCTGAAAGGTGACCTCCGCATCCAGCATACAGTGACGGCCTCCGTGGGA
		CTGCCAGGACCTGCAGAAGCAGCACAGCGATCCCTGCGCCCTCAACCCGCGCATGACCAG
		GTTCTCCGAGGAGGCGTGCGCGGTCCTGACGTCCCCCGGACTGCCAGGACCTGCAGAAGC
		AGCACAGCGATCCCTGCGCCCTCAACCCGCGCATGACCAGGTTCTCCGAGGAGGCGTGCG
		CGGTCCTGACGTCCCCCCGCC-TCAGCTACGGGGAGGACCTGCAGATGGACTGGGATGGC
		CGCGGGAGTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCGACGACTTCCTTACCCCCTCTGGGCTGGCGGAGCCC
		CGGGTGGAGGACTTCGGGAACGCCTGGAAGCTGCACGTGGGGGGGGGGGGGGGGGGGGGG
		GGGGGGG-GGGGGGGGGGGGGGGGGGGGGACATTCGAGGCCTGCCATCGTGCCGTCAGCC
		CGCTGCCCTACCTGCGGAA-\n
		>Sequence_2 \n
		GACCTGCGGGCTGTGTGGCAACTTTAACATCTTTGCTGAAGATGACTTTCAGAGAGAGAG
		AGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGTGGGCTCTGAGCAGTGGAGA
		ACA-GTGGTGTGAACGGGCATCTCCTCCCAGCAGCTCATGCAACATCTCCTCTGGGGAAA
		TGCAGAAGGGCCCGTGGGAGCAAAAAAAAAAAAAAAAAAA-AAAAAAAAAAAAAAAAAAA
		AAAAAAAAAAAACCTGTGCCCAGTAGGGAAT-GGTGCTGTACGGCTGGACCGACCAC-AG
		CGCGTGAAACCCCGTCACTACTAAAAATACAAAAAATTAGCCGGGCGTGGTGGCGGGCGC
		CTGTAGTCCGAGCTAC-TCGGGAGGCTGAGGCAG-GAGAATGGCGTTGCAGCCCAGTGTG
		CCCTGCTGGTATGGAGTATAGGCAGTGTGTGTCCCCTTGCGCCAGG-ACCTGCCAGAGCC
		TGCACATCAATGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGA-AGGCCTCTGCGTGGAGAGCACCGAGTGTCCCTGCGTGCATTCCGGA
		AAGCGCTACCCTCCCGGCACCTCCCT-CTCTCGAGACTGCAACACCTG-CATTTGCCGAA
		ACAGCCAGTGGATCTGCAGCAATGAAGAATGTCCAGGGGAGTGCCTTGTC-ACAGGTC-A
		ATCACACTTCAAGAGCTTTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		TGCTGGCCCGGGATTGCCAGGAC-CACTCCTTCTCCAGTGTCATCGAGACTGTCCAGTGT
		-GCTGATGACCGCGACGCTGTGTGCACCCGCTCCGTAACCGTCC-GGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTGCCATGGA-TGGCCAGGACGTC
		CAGCTCCCCCTCCTGAA-GGTGACCTCCGGATCCAGCATACAGTGACGGCCTCCGTGGGA
		CTGCCAGGACCGGCAGAAGCAGCACAGCGATCCCTGCGCCCTCAACCCGCGCATGACCAG
		GTTCTCCGAGGAGGCGTGCGCGGTCCTGACGTCCCCCGGACTGCCAGGACCTGCAGAAGC
		AGCACAGCGATCCCTGCGCCCTCAACCCGCGCATGACCAGGTTCTCCGAGGAGGCGTGCG
		CGGTCCTGACGTCCCCCCGCC-TCAGCTACGGGGAGGACCTGCAGATGGACTGGGATGGC
		CGCGGGAGTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCGACGACTTCCTTACCCCCTCTGGGCTGGCGGTGCCC
		CGGGTGGAGGACTTCGGGAACGCCTGGAAGCTGCACGTGGGGGGGGGGGGGGGGGGGGGG
		GGGGGGGTGGGGGGGGGGGGGGGGGGGGGACATTCGAGGCCTGCCATCGTGCCGTCAGCC
		CGCTGCCCTACCTGCGGAA-\n
		>Sequence_3 \n
		GACCTGCGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTCAGAGAGAGAG
		AGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGTGGGCTCTGAGCAGTGGAGA
		ACA-GTGGTGTGAACGGGCATCTCCTCCCAGCAGCTCATGCAACATCTCCTCTGGGGAAA
		TGCAGAAGGGCCCGTGGGAGCAAAAAAAAAAAAAAAAAAA-AAAAAAAAAAAAAATAAAA
		AAACAAAAAAAACCTGTGCCCAGTAGGGAAT-GGTGCTGTACGGCTGGATCGACCAC-AG
		CGCGTGAAACCCCGTCACTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCGGGCGC
		CTGTAGTCCGAGCTAC-TCGGGAGGCTGAGGCAG-GAGAATGGCGTTGCAGCCCAGTGTG
		CCCTGCTGGTATGGAGTATAGGCAGTGTGTGTCCC-TTGCGCCAGG-ACCTGCCAGAGCC
		TGCACATCAATGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGA-AGGCCTCTGCGGGGAGAGCACCGAGTGTCCCTGCGTGCATTCCGGA
		AAGCGCTACCCTCCCGGCACCTCCCT-CTCTCGAGACTGCAACACCTG-CATTTGCCGAA
		ACAGCCAGTGGATCTGCAGCAATGAAGAATGTCCAGGGGAGTGCCTTGTC-ACAGGTC-A
		ATCACACTTCAAGAGCTTTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		TGCTGGCCCGGGATTGCCAGGAC-CACTCCTTCTCCAGTGTCATCGAGACTGTCCAGTGT
		-GCTGATGACCGCGACGCTGTGTGCACCCGCTCCGTAACCGTCCCGGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTGCCATGGA-TG-CCAGGACGTC
		CAGCTCCCCCTCCTGAA-GGTGACCTCCGGATCCAGCATACGGTGACGGCCTCCGTGGGA
		CTGCCAGTACCGGCAGAAGCAGCACAGCGATCCCTGCGCCCTCAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCGCGGTCCTGACGTCCCCCGGACTGCCAGGACCTGCAGGAGC
		AGCACAGCGATCCCTGCGCCCTCAACCCGCGCATGACCAGGTTCTCCGAGGAGGCGTGCG
		CGGTCCTGACGTCCCCCCGCC-TCAGCTACGGGGAGGACCTGCAGATGGACTGGGATGGC
		CGCGGGAGTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCGACGACTTCCTTACCCCCTCTGGGCTGGCGGTGCCC
		CGGGTGGAGGATTTCGGGAACGCCTGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGTGGGTGGGGGGGGGGGGGGGGGGGGGACATTCGAGGCCTGCCATCGTGCCGTCAGCC
		CGCTGCCCTACCTGCGGAA-\n
		>Sequence_4 \n
		GACCTGCGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTCAGAGAGAGAG
		AGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGAGTGGGCTCTGAGCAGTGGAGA
		ACA-GTGGTCTGAACGGGCATCTCCTCCCAGCAGCTCATGCAACATCTCCTCTGGGGAAA
		TGCAGAAGGGCCCGTGGGAGCATAAAAAAAAAAAAAAAAA-AAAAAAAAAAAAAATAAAA
		AAACAAAAAAAACCTG-GCCCAGTAGGGCAT-GGTGCTGTACGGCTGGATCGACCAC-AG
		CGCGTGAAACCCCGTCACTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCGGGCGC
		CTGTAGTCCGAGCTAC-TCGGGAGGCTGAGGCAG-GAGAATGGCGTTGCAGCCCAGTGTG
		CCCTGCTGGTATGGAGTATAGGCAGTGTGTGTCCC-TTGCGCCAGG-ACCTGCCAGAGCC
		TGCACATCAATGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGA-AGGCCTCTGCGGGGACAGCACCGAGTGTCCCTGCGTGCATTCCGGA
		AAGCGCTACCCTCCCGGCACCTCCCT-CTCTCTAGACTGCAACACCTG-AATTTGCCGAA
		ACAGCCAGTGGATCTGCAGCAATGAAGAATGTCCAGGGGTGTGCCTTGTC-ACAGGTC-A
		ATCACACTTCAAGAGCTTTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		TGCTGGGCCGGGATTGCCAGGAC-CACTCCTTCACCAGTGTCATCGTGACTGTCCACTGT
		-GCTGATGACCGCGACGCTGTGTGCACCCGCTCCGTAACCGTCCCGGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTGCCATGGA-TG-CCAGGACGTC
		CAGCTCCCCCTCCTGAA-GGTGACCTCCGGATCCAGCATACGGTGACGGCCTCCGTGGGA
		CTGCCAGTACCGGCAGAGGCAGCACAGCGATCCCTGCGCCCTCAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCGTGGTCCTGATGTCCCCCGGACTGCCAGGACCTGCAGGAGC
		AGCACAGCGATCCCTGCGCCCTCAACCCGCGCATGACCAGGTTCTCCGAGGAGGCGTGCT
		CGGTCCTGACGTTCCCCCGCC-TCAGCTACGGGGAGGACCTGCAGATGGACTGGGATGGC
		CGCGGGAGTCTCACTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCGACGACTTCCTTACCCCCTCTGGGCTGGCGGTGCCC
		CGGGTGGAGGATTTCGGGAACGCCTGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGTGGGTGGGGGGGGGGGGGGAGGGGGGACATTCGAGGCCTGCCTTCGTGCCGTCAGCC
		CGCTGCCCTACCTGCGGAA-\n
		>Sequence_5 \n
		GACCTGCGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTCAGAGAGAGAG
		AGAGAGAGAGGGAGAGAGAGAGAGAGAGAGAGAGAGAGAGTGGGCTCTGAGCAGCGGAGA
		ACA-GTGGTCTGAACGGGCATCTCCTCCCAGCAGCTCATGCAACATCTCCTCTGGGGAAA
		TGCAGAAGGGCCCGTGGGAGCATAAAAAAAAAAAAAAAAA-AAAAAAAAAAAAAATAAAA
		AAACAAAAAAAACCTG-GCCCAGTAGGGCAT-GGTGCTGTACGGCTGGATCGACCAC-AG
		CGCGTGAAACCCCGTCACTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCGGGCGC
		CTGTAGTCCGAGCTACCTCTGGAGGCTGAGGCAG-GAGAATCGCGTTGCAGCCCAGTGTG
		CCCTGCTGGTATGGAGTATAGGCAGTGTGGGTCCCATTGCGCCAGGTACCTGCCAGAGCC
		TGCACATCATTGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGA-AAGCCTCTGCGGGGACAGCACCGAGTGTCCCTGCGTGCATTCCAGA
		AAGCGCTACCCTCCCGGCACCTCCCT-CTCTCTAGACTGCAACACCTG-AATTTGCCGAA
		ACAGCCAGTGGATCTGCAGCAATGAAGAATGTCCAGGGGTGTGCCTTGTCTACAGGTC-A
		ATCACACTTCAAGAGCTTTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		TGCTGGGCCGGGATTGCCAGGAC-CACTCCTTCACCAGTGTCATCGTGACTGTCCACTGT
		-GCTGATGACCGCGACGCTGTGTGCACCCGCTCCGTAACCGTCCCGGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTACCATGGA-TG-CCAGGACGTC
		CAGCTCCCCCTCCTGAA-GGTGACCTCCGGATCCAGCATACGGTGACGGCCTCCGTGGGA
		CTGCCAGTACCGGCAGAGGCAGCACAGCGATCCCTGC-CCCTCAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCGTGGTCCTGATGTCCCCCGGACTGCCAGGACCTGCAGGAGC
		AGCACAGCGATCCCTGCGCCCTCAACCCGCGCATGACCAGGTTCTCCGAGGAGGCGTGCT
		CGGTCCTGACGTTCCCCCGCC-TCAGCTACGGGGAGGACCTGCAGATGGAATGGGATGGC
		CGCAGGAGTCTCACTCTCTCTCTCTCTCTCTCTCTCTCTCTCTCTTTCTCTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCGACGACCTCCTTACCCCCTCTGGGCTGGCGGTGCCC
		CGGGTGGAGGATTTCGGGAACGCCTGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGTGGGTGGGGGGGGGGGGGGAGGGGGGACATTCGAGGCCTGCCTTCGTGCCGTCAGCC
		CGCTGCCCTACCTGCGGAA-\n
		>Sequence_6 \n
		GACCTGCGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTCAGAGAGACAG
		AGAGAGAGAGGGAGAGAGAGAGAGAGGGAGAGAGAGAGAGTGGGCTCTGAGCAGCGGAGA
		ACA-GTGGTCTGAACGGGCATCTCCTCCCAGCAGCTCATGCAACATCTCCTCTGGGGAAA
		TGCAGAAGGGCCCGTGGGAGCATAAAAAAAAAAAAAAAAA-AAAAAAAAAAAAAATAAAA
		AAACAAAAAAAACGTG-GCCCAGTAGGGCAT-GGTGCTGTACGGCTGGATCGACCAC-AT
		CGCGTGAAACCCCGTCACTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCCGGCGC
		CTGTAGTCCGAGCTACCTCTGGAGGCTGAGGCAG-GAGAATCGCGTTGCAGCCCAGTGTG
		CCCTGCTGGTATGGAGTATAGGCAGTGTGGGTCCCATTGCGCCAGGTACCTGACAGAGCC
		TGCACATCATTGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGA-AAGCCTCTGCGGGGACAGCACCCAGTGTCCCTGCGTGCATTCCAGA
		AAGCGCTACCCTCGCGGCACCTCCCT-CTCTCTAGACTGCAACACCTG-AATTTGCCGAA
		ACAGCCAGTGGATCTGCAGCAATGAAGAATGTCCAGGGGTGTGCCTTGTCTACAGGTC-A
		ATCACACTTCAAGAGCTTTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		TGCTGGGCCGGGATTGCCAGGAC-CACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		-GCTGATGACCGCGACACTGTGTGCACCCGCACAGTAACCGTCCCGGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTACCATGGA-TGCCCAGGACGTC
		CAGCTCCCCCTCCTGAA-GGTGACCTCCGGATCCAGCATACGGTGACGGCCTCCGTGGGA
		CTGCCAGTACCGGCAGAGGCAGCACAGCGATCCCTGC-CCCTTAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCG-GGTCCTGATGTCCCCCGGACTGCCAGGACCTGCAGGAGC
		AGCACAGCGATCCCTGCGCCCTCAACCCGCGCATGACCAGGTTCTCCGAGGAGGCGTGCT
		CGGTCCTGACGTTCCCCCGCC-TCAGCTACGGGGAGGACCTGCAGATGGAATGGGATGGC
		CGCAGGAGTCTCACTCTCTCCCTGTCTCTCTCTCTCTCTCTCTCTTTCTCTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCGACGACCTCCTTACCCCCTCTGGGCTGGCGGTGCCC
		CGGTTGGAGGATTTCGGGAACGCCTGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGTGGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCTGCCTTCGTGCCGTCAGCC
		CGCTGCCCTACCTGCGGAA-\n
		>Sequence_7 \n
		GACCTGCGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTCAGAGAGACAG
		AGTGAGAGAGGGAGAGAGAGAGAGAGGGAGAGAGAGAGAGTGGGCTCTGAGCAGCGGAGA
		AAA-GTGGTGTGAACGGGCATCTCCTCCCAGCAGCTCATGCAATATCTCCTCTGGGGAAA
		TGCAGAAGGGCCCGTGGGAGCATAAAAAAAAAACAAAGAA-AAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGTG-GCCCAGTAGGGCAT-GGTGCTGTACGGCTGGATCGACCAC-AT
		CGCGTGAAACCCCGTCGCTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCCGGCGC
		CTGTAGTCCGAGCTACCTCTGGAGGCTGAGCCAG-GAGAATCGCGTTGCAGCCCAGTGTG
		CCCTGC-GGTATGGAGTATAGGCAGTGTGGGTCCCATTGCGCCAGGTACCTGACTGAGCC
		TGCACATCATTGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGA-AAGCCTCTGCGGGGACAGCACCCAGTGTCCCTGCGTGCATTCCAGA
		GAGCGCTACCCTCGCGGCACCTCCCT-CTCTCTAGACTGCAACACCTG-AATTTGCCGAA
		ACAGCCAGTGGATCTGCAGCAATGAAGAATGTCCAGGGGTGTGCCTTGTCTACAGGTC-A
		ATCACACTTCAAGAGCTTTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		TGCTGGGCCGGGATTGCCAGGAC-CACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		-GCTGATGACCGCGACACTGTGTGCACCCGCACAGTAACCGACC-GGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTACCATGGA-TGCCCAGGACGTC
		CAGCTCCCCCTCCTGAT-GGTGACCTCCGGATCCAGCATACGGTGACGGCCTCCGTGGGA
		CTGCCAGTACTGGCAGAGGCAGCACAGCGATCCCTGC-CCCTTAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCG-GGTCCTGATGTCCCCCGGACTGCCAGGACCTGCAGGAGC
		AGCACCGCGATCCCTGCGCCCTCAACCCGCGCATGACCAGGTTCTCCGAGGAGGCGTGCT
		CGGTCCTGACGTTCCCCCGCC-TCAGCTACGGGGAGGACCTGCAGATGGAATGGGATGGC
		CGCAGGAGTCTCACTCTCTCCCTGTCTCTCTCTCTCTCTCTCTCTTTCTCTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCGACGACCTCCTTACCCCCTCTGGGCTGGCGGTGCCC
		CGGTTGGAGGATTTCGGGAACGCCCGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGTGGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCTGCCTTCGTGCCGTCAGCC
		CGCTGCCCTACCTGCGGAA-\n
		>Sequence_8 \n
		GACCTGCGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTCAGAGAGACAG
		AGTGAGAGAGGGAGAGAGAGAGAGAGGGAGAGAGAGAGAGTGGGCTCTGAGCAGCGGAGA
		AAA-GTGGTGTGAACGGGCATCTCCTCCCAGCAGTTCAAGCAATGTCTCCTCTGGGGAAA
		TGCAGAAGGGCCCGTGGGAGCATAAAAAAAAAACAAAGAA-AAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGTG-GCCCAGTAGGGCAT-GGTGCTGTACGGCTGGATCGACCAC-AT
		CGCGTGAAACCCCGTCGCTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCCGGCGC
		CGGTAGTCCGAGCTACCTCTGGAGGCTGAGCCAGAGAGAATCGCGTTGCAGCCCAGTGTG
		CCCTGC-GGTATGGAGTATAGGCAGTGTGGGTCCCATTGCGCCAGG-ACCTGACTGAGCC
		TGCACATCATTGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGA-AAGCCTCTACGGGGACAGCACCCAGTGTCCCTGCGTGCATTCCAGA
		GAGCGCTACCCTCGCGGCACCTCCCT-CTCTCTAGACTGCAACACCTG-AATTTGCCGAA
		ACAGCCAGTGGATCTGCAGCAATGAAGAATGTCCAGGGGTGTGCCTTGGCTACAGGTC-A
		ATCACACTTCAAGAGCTTTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		TGCTGGGCCGGGAATGCCAGGAC-CACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		TGCTGATGACCGCGACACTGTGCGCACCCGCACAGTAACCGACC-GGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTACCATGGAACCACCAGGACGTC
		CAGCTCCCCCTCCTGAT-GGTGACCTCCGGATCCAGCATACGGTGACGGCCTCCGTGGGA
		CTGCCAGTACTGGCAGAGGCAGCACAGCGATCCCTGC-CCCTTAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCG-GGTCCTGATGTCCCCCGGACTGCCAGGACCTGCAGGAGC
		AGCAACGCGATCCCTGCGCCCTCAACCCGCGCATGACCAGGTTCTCCGAGGAGGCGTGCT
		CGGTCCTGACGTTCCCCCGCCATCAGCTACGGGGAGGACCTGCAGATGGAATGGGATGGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCTC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCGACGACCTCCTTACCCCCTCTGGGCTGGTGGTGCCC
		CGGTTGGAGGATTTCGGGAACGCCCGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGAGGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCTGCCTTCGTGCCGTCAGCC
		CGCTGCCCTACCTGCGGAC-\n
		>Sequence_9 \n
		GACCTGCGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTCAGAGTGACAG
		TGTGAGAGAGGGAGAGTGAGAGAGAGGGAGAGAGAGAGAGTGGGCTCTGAGCAGCGGAGA
		AAA-GTGGTGTGAACGGGCATCTCCTCCCAGCAGTTCAAGCAATGTCTCCTCTGGGGAAA
		TGCAGAAGGACCCGTGGGAGCATAAAAAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGTG-GCCCAGTAGGGCAT-GGTGCTGTACGGCTGGATCGACCAC-AT
		CGCGTGAAACCCCGTCGCTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCCGGCGC
		CGGTAGTCCGAGCTACCTATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTG
		CCCTGC-GGTATGGCGTATAGGCAGTGTGGGTCCCATTGCGCCAGG-ACCTGACTGAGCC
		TGCACATCACTGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGAGAAGCCTCTACGGGGACAGCACCCAGTGTCCCTGCGTGCATTCCAGA
		GAGCGCTACCCTCGCGGCACCTCCTCGCTCTCTAGACTGCAACACCTG-AATTTGCCGAA
		ACAGCCAGTGGATCTGCAGCAACGAAGAATGTCCAGGGGTGTGCCTTGGCTACAGGTCCA
		ATCACACTTCAAGAGCTCTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		TGCTGGGCCGGGAATGCCAGGAC-CACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		TGCTGATGACCGCGACGCTGTGCGCACCCGCACAGTAACCGACC-GGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTACCATGGAACCACCAGGACGTC
		CAGCTCCCCCTCCTGAT-GGGGACCTCCGGATCCAGCATACGATGACGGCCTCCGTGGGA
		CTGCCAGTACTGGGAGAGGCAGCACAGCGATCCCTGC-CCATTAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCG-GGTCCTGATGTCCCCCGGACTGACAGGACCTGCAGGAGC
		AGCAACGCGATCCCTGCGCCCTCAACCCGAGCATGACCAGGTTCTCCGAGGAGGCGTGCT
		CGGTCCTGACGTTCCCCCGCCATCAGCTACGGGGAGGACCTGCAGATGGAATGGGATGGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCTC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCGACGACCTCCTTACCCCCTCTGGGCTGGTGGTGCCC
		CGGTTGGAGGATTTCGGGAACGCCCGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGAGGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCTGCCTTCGTGCCGTCAGCC
		CGCTGCCCTACCTGCGGAC-\n
		>Sequence_10 \n
		GACCTGCGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTCAGAGTGACAG
		TGTGAGAGAGGGAGAGTGAGAGAGAGGGAGAGAGAGAGAGTGGGCTCTGAGCAGCGGAGA
		AAA-GTGGTGTGAACGGGCATCTCCTGCCAGCAGTTCAAGCAATGTCTCCTCTGGGGAAA
		TGCAGAAGGACCCGTGGGAGCATAAAAAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGTG-GCCCAGTAGGGCAT-GGTGCTGTACGGCTGGATCGTCCACTAT
		CGCGTGAAACCCCGTCGCTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCCGGCGC
		CGGTAGTCCGAGCTACCTATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTG
		CCCTGC-GCTATGGCGTATAGGCAGTGTGGGTCCCATTGCGCCAGG-ACCTGACTGAGCC
		TACACATCACTGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGAGAAGCCTCTACGGGGACAGCACCCAGTGTCCCTGCGTGCATTCCAGA
		GAGCGCTACCCTCGCGGCACCTCCTCGCTCTCTAGACTGCAACACCTG-AATTTGCCGAA
		ACAGCCAGTGGATCTGCAGCAACGAAGAATATCCAGGGGTGTGCCTTGGCTACAGGTCCA
		ATCACACTTCAAGAGCTCTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		TGCTGGGCCGGGAATGCCAGGAA-CACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		TGCTGATGACCGCGACGCTGCGCGCACCCGCACAGTAACCGACC-GGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTACCATGGAACCACCAGGACGTC
		CAGCTCCCCCTCCTGAT-GGGGACCTCCGGATCCAGCATACGATGACGGCCTCCGTGGGA
		CTGCCAGTACTGGGAGAGACAGCTCAGCGATACCTGC-CCATTAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCG-GGTCCTGATGACCCCCGGACTGACAGGACCTGCAGGAGC
		AGCAACGCGATCCCTGCGCCCTCAACCCGAGCATGACCAGGTTCTCCGAGGAGGCGTGCT
		CGGTCCTGACGTTCCCCCGCCATAAGCTACGGGGAGGACCTGCAGATGGAATGGGATGGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCTC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCCACGACCTCCTTACCCCCTCTGGGCTGGTGGTGCCC
		CGGTTGGAGGATTTCGGGAACGCCCGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGAGGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCTGCCTTCGTGCCGTCAGCC
		CGCTGCCCTACCTGCGGAC-\n
		>Sequence_11 \n
		GAACTGCGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTCAGAGTGACAG
		TGTGAGAGAGGGAGAGTGAGAGAGAGGGAGAGAGAGAGAGTGGGCTCTGAGCAGCGGAGA
		AAA-GTGGTGTGAACGGGCATCTCCTGCCAGCAGTTAAAGCAATGTCTCCTCTGGGGAAA
		TGCAGAAGGACCCGTGGGAGCATAAAAAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGTG-GCCCAGTAGGGCAT-GGTGCTGTACGGCTGGATCGTCCACTAT
		CGCGTGAAACCCCGTCGCTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCCGGCTT
		CGGTAGTCCGAGCTACCTATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTG
		CCCTGC-GCTATGGCGTATAGGCAGTGTGGGTCCCATTGCGCCAGG-ACCTGACTGAGCC
		TACACATCGCTGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGAGAAGCCTCTCCGGGGACAGCACCCAGTGTCCCTGCGTGCATTCCAGA
		GAGCGCTACCCTCGCGGCACCTCCTCGCTCTCTAGACTGCAACACCTG-AATTTGCCGAA
		ACAGCCAGTGGAACTGCAGCAACGAAGAATATCCAGGGGTGTGCCTTGGCTACAGGTCCA
		ATCACACTTCAAGAGCTCTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		AGCTGGGCCGGGAATGCCAGCAA-CACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		TGCTGATGACCGCGACGCTGCGCGCACCCGCACAGTAACCGACC-GGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTAGCATGGAACCACCAGGACGTC
		CAGCTCCCCCTCCTCAT-GGGGACCTCCGGATCCAGCATACGATGACGGCCTCCGTGGGA
		CTGCCAGTACTGGGAGAGACAGCTCAGCGATACCTGC-CCATTAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCG-GGTCCTGATGACCCCCGGACTGACAGGACCTGCAGGAGC
		AGCAACGCGATCCCTGCGCCCTCAACCCGAGCATGACCAGGTTCTCCGAGGAGGCGTGCT
		CGGTCCTGACGTTCCCCCGCCATAAGCTACGGGGAGGACCTGCGGATGGAATGGGATGGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCTC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCCACGACCTCCTTACCCCCTCTGGGCTGGTGGTGCCC
		CGGTTGGAGGATTTCGGGAACGCCCGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGACGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCTGCCTTCGTGCCGTCAGCC
		CGCTGCCCTACCTGCCGGAC\n
		>Sequence_12 \n
		GAACTGCGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTTAGAGTGACAG
		TGTGAGAGAGGGAGAGTGAGAGAGAGGGAGAGAGAGAGAGTGGACTCTGAGCAGCGGAGA
		AAA-GTGGTGTGAACGGGCATCTCCTGCCAGCAGTTAAAGCAATGTCTCCTCTGGGGAAA
		GGCAGAAGGACCCGTGGGAGCATAAAAAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGTG-GCCCAGTAGGGCAT-GGTGCTGTACGGCTGGATCGTCCACTAT
		CGCGTGAAACCCCGTCGCTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCCGGCTT
		CGGTAGGTCGAGCTACCTATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTG
		CCCTGC-GCTATGGCGAATAGGCAGTGTGGGTCCCATTGCGCCAGG-ACCTGACTGAGCC
		TACACATCGCTGAAATGTGTCAGGAGCGATGCGTGGATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGAGAAGCCTCTCCGGGGACAACACCCAGTGTCCCTGCGTGCATTCCAGA
		GAGCGCTACCCTCGCGGCACCTTCTCGCTCTCTAGACTGCAACACCTG-AATTTGCCGAA
		ACAGCCAGTGGAACTGCAGCAACGAAGAATATCCAGGGGTGTGCCTTGGCTACAGGTCCA
		ATCACACTTCAAGAGCTCTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		AGCTGGGCCGGGAATGCCAGCAA-CACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		TGCTGATGACCGCGACGCTGCGCGCACCCGCACAGTAACCGACG-GGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTAGCATGGAACCACCAGGACGTC
		CAGCTTCCCCTCTTCAT-GGGGACCTCCGGATCCAGCATACGATGACGGCCTCCGTGGGA
		CTGCCAGTACTGGGAGAGACAGCTCAGCGATACCTGC-CCATTAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCG-GGTCCTGATGACCCCCGGACTGACAGGACCTGCAGGAGC
		AGCAACGCGATCCCTGCGCCCTCAACCCGAGCATGACCAGGTTCTCCGAGGAGGCGTGCT
		CGGTCCTGACGTTCCTCCGCC-ATAGCTACGGGGAGGACCTGCGGATGGAATGGGATGGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCTC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACAATGGCAACCAGGGCCCCGACCTCCTTACCCCCTCTGGGCTGGTGGTGCCC
		CGGTTGGAAGATTTCGGGAACGCCCGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGACGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCTGCCGTCGTGCCGTCAGCC
		CGCTGCCCTACCTGCCGGAC\n
		>Sequence_13 \n
		GAACTGTGGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATGACTTTTAGAGTGACAG
		TGTGAGAGAGGGAGAGTGAGAGAGAGGGAGAGAGAGAGAGTGGACTCTGAGCAGCGGAGA
		AAA-GTGGTGTGAACGGGCATCTCCTGCCAGCAGTTAAAGCAATGTCTCCTCTGGGGAAA
		GGCAGAAGG-CCCGTGGGAGCATAAAGAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGTG-GCCCAGTAGGGCATCGGTGCTGTACGGCAGGATCGTCCACTAT
		CGCGTGAAACCCCGTCGCTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCCGGCCT
		CGGTAGGTCGAGCTACCTATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTG
		ACCTTC-GCTATGGCGAATAGGCAGTGTGGGTCCCATTGCGCCAGG-ACCTGACTGAGCC
		TACACATCGCTGAAATGTGTCAGGAGCGATGCGTGTATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGAGAAGCGTCTCCGGGGACAACACCCAGTGTCCCTGCGTGCATCCCAGA
		GAGCGCTACCCTCGCGGCACCTTCTCGCTCTCTAGACTTCAACACCTG-AATTTGCCGAA
		ACAGCCAGTGGAACTGCAGCAACGAAGAATATCCAGGGGTG-GCCTTGGCTACAGGTCCA
		ATCACACTTCAAGAGCTCTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCCAGTACC
		CGCTGGGCCGGGAATGCCAGCAA-CACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		TGCTGATGACCGCGACGCTGCGCGCACCCGCACAGTAACCGACG-GGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTAGCATGGAACCACCAGGACGTC
		CAGCTTCCCCTCTTCAT-GGGGACCTCCGGATCCAGCATACGATGACGGCCTCCGTGGGA
		CTGCCAGTACTAGGAGAGACAGCTCAGCGATACCTGC-CCATTAACCCGCGCATGACCAG
		GTTCTGCGAGGAGGCGTGCG-GGTCCTGATGACCCCCGGACTGACAGGACCTGCAGGAGC
		AGCAACGCGATCCCTGCGCCCTCAACCCGAGCATGACCAGGATCTCCGAGGAGGTGTGCT
		CGGTCCTGACGTTCCTCCGCC-ATAGCTACGGGGAGGACCTGCGGATGGAATGGGATAGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCTC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACACTGGCAACCAGGGCCCCGACCTCCTTACCCCCTCTGGGCTGGTGGTGCCC
		CGGTTGGAAGATTTCGGGAACGCCCGGAAGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGACGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCAGCCGTCGTGCCGTCACCC
		CGCTGCCCTACCTGCCGGAC\n
		>Sequence_14 \n
		GAACTGTCGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATCACTTTTAGAGTGACAG
		GGTGACAGAGGGAGAGTGAGAGAGTGGGAGAGAGAGAGAGTGGACTCTGAGCAGCGGAGA
		AAAAGTGGTGTGAACGGGCATCTCCTGCCAGCAGTTAAAGCAATGTCTCCTCTGGGGAAA
		GGCAGAAGT-CCCGTGGGAGCATAAAGAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGTG-GCCCAGTAGGGCATCGGTGCTGTACGGCAGGATCGTCCACTAT
		CGCGTGAAACCCCGTCGCTACTAAAAATACAAAAAATTAGCCGGGTGTGGTGGCCGGCCT
		CGGTAGGTCGAGCTACCGATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTT
		ACCTTC-GCTATGGCGAATAGGCAGTGTGGGTCCCATTGCGCCAGG-ACCTGACTGAGTC
		TACACATCGCTGAAATGTGTCAGGAGCCATGCGTGTATGGCTGCAGCTGCCCTGAGGGAC
		AGCTCCTGGATGAGAAGCGTCCCCGGGGACAACACCCAGTGTCCCTGCGTGCATCCCAGA
		GAGCGCTACCCTCGCGGCACCTTCTCGCTCTCTAGACTTCAACACCTGACATTTGCCGAA
		ACAGCCAGTGGAACTGCAGCAACGAAGAATATCCAGGGGTGTGCCTTGGCTACAGGTCCA
		ATCACACTTCAAGAGCTCTGACAACAGATACTTCAC-CTTCAGTGGGATCTGCTAGTACC
		CGCTGGGCCGGGAATGCCAGCCA-CACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		TGCTGATGACCGCGACGCTGCGCGCACCCGCACAGTAACCGACG-GGCTGCCTGGCCTCC
		ACAACAACCTTGTGAAACTGAAGCATGGGGCAGGAGTTAGCATGGAACCACCAGGACGTC
		CAGCTTCCCCTCTTCAT-GGGGACCTCCGGATCCAGCATACGATGACGGCCTCCGTGGGA
		CTGCCAGTACTAGGCGAGACAGCTCAGCCATACCTGC-CCATTAACCCGCGCATGACCAG
		GTTTTGCGAGGAGGCGTGCG-GGTCCTGATGACCCCCGGACTGACAGGACCTGCAGGAGC
		AGCAACGCGATCCCTGCGCCCTCAACCCGAGCATGACCAGGATCTCCGAGGAGGTGTGCT
		CGGTCCTGACGTGCCTCCGCC-ATAGCTACGGGGAGGACCTGCGGATGGAATGGGATAGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCGC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACACTGGCTACCAGGGCCCCGACCTCCTTACTCCCTCTGGGCTGGTGGTTCCC
		CGGTTGGAAGATTTCGGGAAAGCCCGGACGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGACGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCAGCCGTCGTGCCGTCACCC
		CGCTGCCCTACCTGCCGGAC\n
		>Sequence_15 \n
		GAACTGACGGCTGTGTGGCAACTTTAACATCTT-GCTGAAGATCACTTTTCGAGTGACAG
		GGTGACAGAGGGAGAGTGAGAGAGTGGGAGAGAGAGAAAGTGGACTCTGAGCAGCGGAGA
		AAAAGTGGTGTGAACGGGCATCTCCTGCCAGCAGTTAAAGCACTGTCTCCTCTGGGGAAA
		GGCAGATGT-CCCGTGGGAGCATAAAGAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGTG-GCCCAGTAGGGCATCGGTGCTGTATGGCAGGATCGTCCACTAT
		CGCGTGAAACCCCGTCGCTACTAAAA-TACAAAAAATTAGCCGGGTGTGGTGGCCGGCCT
		CGGTAGGTCGAGCTACCGATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTT
		ACCTTC-GCGATGGCGACTAGGCAGTGTGGGTCTCATTGCGCCAGG-ACCTGACTGAGTC
		TACACATCGCTGAAATGTGTCAGGAGCCATGCGTGTATGGCTGCAGCTGCCCTGAGG-AC
		AGCTCCTGGATGC-ACGCGTCCCCGGGGACAACACCCAGTGTCCCTGCGTGCATCCCAGA
		GAGCGCTACCCTCGCGGCACCTTCTCGCTCTCTAGACTTCAACACCTGACATTTGCCGAA
		ACAGCCAGTGGAACTGCAGCAACGAAGAATATCCAGGGGTGTGCCTTGGCTACAGGTCCA
		ATCACACTTCAAGAGCTCTGACAACGGATACTTCAC-CTTCAGTGGGATCTGCTAGTACC
		CGCTGGGCCGGGAATGCCAGC-CACACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		TGCTGATGACCGCGACGCTGCGCGCACCCGCACAGTAACCGACG-GGCTGCCTGGCCTCC
		ACAACAATCTTGTGAAACTGAAGCATGGGGCAGGAGTTAGCATGGAACCACCAGGACGTC
		CAGCTGCCCCTCTTCAT-GGGGACCTCCGGATCCAGCATACGATGACGGCCTCCGTGGGA
		CTGCCAGTACTAGGCGAGACAGCTCAGCCATACCTGC-CCATTAACCCGCGCATGACCAG
		GTTTTGCGAGGAGGCGTGCG-GGTCCTGATGACTCCCGCACTGACAGGACCTGCAGGAGC
		AGCAACGCGATCCCTGCGCCCTCAACCCGAGCATGAGCAGGATCTACGAGGAGGTGTGCT
		GGGTCCTGACGTGCCTCCGCC-ATAGCTACGGGGAGGACCTGCGGATGGAATGGGATAGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCGC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACACTGGCTACCAGGGCCCCGACCTCCTTACTCCCTCTTGGCTGGTGGTTCCC
		CGGTTGGAAGATTTCGGGAAAGCCCGGACGCTGCACGTGGAGGGGGGGGGGGGGGGGGGG
		GGGACGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCAGCCGTCGTGCCGTCACCC
		CGCTGCCCTACCTGCCGGAC\n
		>Sequence_16 \n
		GAACTGACGGCTGTGTGGCAACGTTAACATCTT-GCTGAAGATCATTTTTCAAGTGACAG
		GGTGACAGAGGGAGAGTGAGAGAGTGGGAGAGAGAGAAAGTGGACTCTGAGCAGCGGAGA
		AAA-GTGGTGTGAACGGGCATCTCCTGCCAGCAGTTAAAGCACTGTCTCCTCTGGGGAAA
		GGCAGATGT-CCCGTGGGAGCATAAAGAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGGG-GCCCAGTAGGGCATCGGTGCTGTATGGCAGGATCGTCCACTAT
		CGCGTGAAACCCCGTCGCTACTAAAA-TACAAAAAATTAGCCGGGTGTGGTGGCCGGCCT
		CGGTAGGTCGAGCTACCGATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTT
		ACCTTC-GCGATGGCGACTAGGCAGTGTGGGTCTAATTGCGGCAGG-ACCTGACTGAGTC
		TACACATCGCTGAAATGTGTCAGGAGCCATGCGTGTATGGCTGCAGCTGCCCTGAGG-AC
		AGCTCCTGGATGC-ACGCGTCCCCGGGGACAACATCCAGTGTCCCTGCGTGCA-CCCAGA
		GAGCGCTACCCTCGCGGCACCTTCTCGCTCTCTAGACTTTAACACCTGACATTTGCCGAA
		ACAGCCAGTGGAACTGCAGCAACGAAGAATATCCAGGGGTGTGCCTTGGCTACAGGTCCA
		ATCACACTTCAAGAGCTCTGACAACGGATACTTCACTCTTCAGTGGGATCTGCTAGTACC
		CGCTGGGCCGGGAATGCCAGC-CACACTCCTTCACCAGTGTCATCGTGACTATCCACTGT
		TGCTGATGACCGCGACGCTGCGCGCACCCGCACAGTAACCGACG-GGCTGCCTGGCCTCC
		ACAACAATCTGGTGAAACAGAAGCATGGGGCAGGAGTTAGCATGGAACCACCAGGACGTC
		CAGCTGCCCCTCTTCAT-GGGGACCTCCGGATCCAGCATACGATGACGGCCTCCGTGGGA
		CTGCCAGTACTAGGCGAGACAGCTCAGCCATACCTGC-CCATTAACCCGCGCATGACCAG
		GTTTTGCGAGGAGGCGTGCG-GGTCCTGATGACTCCCCCACTGACAGGACCTCCAGGAGC
		AGCAACGCGATCCCTACGCCCTCAACCCGAGCATGAGCAGGATCTACGAGGAGGTGTGCT
		GGGTCCTGACGTGCCTCCGCT-T-AGCTACGGGGAGGACCTGCGGATGGAATGGGATAGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCGC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACACTGGCTACCAGGGCGCAGACCTCCTTACTCCCTCTTGGCTGGTGGTTCCC
		CGGTTGGAAGATTTCGGGAAAGCCCGGACGCTGCACGTGGAGGGGGGGGGGGGGGGGGTG
		GGGACGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCAGCC-TCGTGCCGTCACCC
		CGCTGCCGTACCTGCCGGAC\n
		>Sequence_17 \n
		GAACTGACGGCTGTGTGGCAACGTTAACATCTT-GCTGAAGATCATTTTTCAAGTGACAG
		GGTGACAGAGGGAGAGTGAGAGAGTGGGAGAGAGAGACAGTGGACTCTGAGCAGCGGAGA
		AAA-GTGGTGTGAACGGGCATCTCCTGCCAGCAGTTAAAGCACTGTCACCTCTGGGGAAA
		GGCAGATGT-CCCGTGTGAGCATAAAGAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGGG-GCCCAGTAGGGCATCGGTGCTGTATGGCAGGATCGTCCACTAT
		CGCGTGAAACCCCGTCGCTACTAAAA-TACAAAAAATTAGCCGGGTGTGGTGGCCGGCCT
		CGGTAGGTCGAGCTACCGATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTT
		ACCTTC-GCGGTGGCCATTAGGCAGTGTGGGTCTAATAGCGGCAGG-ACCTGACTGAGTC
		CACACATCGCTGAAATGTGTCACGAGCCATGCGTGTATGGCTGCAGCTGCCCTGAGG-AC
		AGCTCCTG-ATGC-ACGCGTCCCCGGGGACAACATCCAGTGTCCCTGCGTGCA-CCCAGA
		GAGCGCTACCCTCGCGGCACCTTCTCGCTCTCTAGACTTTAACACCTGACATTTGCCGAA
		ACAGCCAGTGGAACTGCAGCAACGAAGAATATCCAGGGGTGTGCCTTGGCTACAGGTCCA
		ATCACACTTCAAGAGCTCTGACAACGGATACTTCACTCTTCAGTGGGATCTGCTAGTACC
		CGCTGGGCCGGGAATGCCAGC-CATACTCCTTCACCAGGGTCATCGTGACTATCCACTGT
		TGCTGATGACCGCGACGCTGCGCGCACCCGCACAGTAACCGACG-GGCTGCCTGGCCTCC
		ACAACAATCTGGTGAAACAGAAGCATGGGGCAGGAGTTAGCATGGAACCACCAGGACGTC
		CAGCTGCCCCTCTTCAT-GGGGACCTCCGGATCCAGCATACGATGA-GGCCTCCGTGGGA
		CTGCCAGTACTAGGCGATACAGCTCAGCCATACCTGC-CCATTAACCCGCGCATGACCAG
		GTTTTGCGAGGAGGCGTGCG-GGTCCTGATGACTCCCCCACTGACAGGACCTCCAGGAGC
		AGCAACGCGATCCCTACGCCCTCAACCCGAGCATGAGCAGGATCTACGAGGAGGTGTGCT
		GGGTCCTTACGTGCCTCCGCT-T-AGCTACGGGGAGGACCTGCGGATGGAATGGGATAGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCGC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACACTGGCTACCAGGGCGCAGACCTCCTTACTCCCTCTTGGCTGGTGGTTCCC
		CGGTTGGAAGATTTCGGGAAAGCCCGGACGCTGCACGTGGAGGGGGGGGGGGGGGGGGTG
		GGGAAGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCAGCC-TCGTGCCGTCACCC
		CGCTGCCGTACCTGCCGGAC\n
		>Sequence_18 \n
		GAACTGACGGCTGTGTGGCAACGTTAACATCTT-GCTGAAGATCATTTTTCAAGTGACAG
		GGTGACAGAGGGAGAGTGAGAGAGTGGGAGAGAGAGACAGTGGACTCTGAGCAGCGGAGA
		AAA-GTGGTGTGAACGGGCATCTCCTGCCAGCAGTTAAAGCACTGTCACCTCTGGGGATA
		GGCAGATGT-CCCGTGTGAGCATAAAGAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGGG-GCCCAGTAGGGCATCGGTGCTGTATGGCAGGATCGTCCACTAT
		CGCGTGAAACCCCGTCGCTACTAAAA-TACAAAAAATTAGCCGGGTGTGGTGGCCGGCCT
		CGGTAGGTCGAGCTACCGATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTT
		ACCTTC-GCGGTGGCCATTAGGCAGTGTGGGTCTAATAGCGGCAGG-ACCTGACTGAGTC
		CACACATCGCTGAAATGTGTCACGAGCCATGCGTGTATGGCTGCAGCTGCCCTGAGG-AC
		AGCTCCTG-ATGC-ACGCGTCCCCGGGGACAACATCCAGTGTCCCTGCGTGCA-CCCAGA
		GAGCGCTACCCTCGCGGCACCTTCTCGCTCTCTAGACTTTAACACCTGACATTTGCCGAA
		ACAGCCAGTGGAACTGCTGCAACGAAGAATATCCAGGGGTGTGCCTTGGCTACAGGTCCA
		ATCTCACTTCAAGAGCTCTGACAACGGATACTTTACTCTTCAGTGGGATCTGCTAGTACC
		CGCTGGGCCGGGAATGCCAGC-CATACTCCTTCACCAGGGTCATCGTGATTATCCACTGT
		TGCTGATGACCGCGACGCTGCGCGCACCCGCACAGTAACCGACG-GGCTGCCTGGCCTCC
		ACAACAATCTGGTGAAACAGAAGCATGGGGCAGGAGTTAGCATGGAACCACCAGGACGTC
		CAGCTGCCCCTCTTCAT-GGGGACCTCCGGATCCAGCATACGA-GA-GGCCTCCGTGGGA
		CTGCCAGTACTAGGCGATACAGCTCAGCCATACCTGCACCATTAACCCGCGCATGACCAG
		GTTTTGCGAGGAGGCGTGCG-GGTCCTGATCACTCCCCCACTGACAGGACCTCCAGGAGC
		AGCAACGCGATCCCTACGCCCTCAACCCGAGCATGAGCAGGATCTACGAGGAGGTGTGCT
		GGGTCCCTAAGTGCCTCCGCT-T-AGCTACGGGGAGGACCTGCGGATGGAATGTGATAGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCGC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACACTGGCTACCAGGGCGCAGACCTCCTTACTCCCTCTTGGCTGGTGGTTCCC
		CGGTTGGATGATTTCGGGAAAGCACGTACGCTGCACGTGGAGGGGGTGGGGGGGGGGGCG
		GGGAAGGTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCATCC-TCGTGCCGTCACCC
		CGCTGCCGTACCTGCCGGAC\n
		>Sequence_19 \n
		GAACTGACAGCTGTGTGGCAACGTTAACATCTT-GCTGAAGATCATTTTTCAAGTGACAG
		GGTGACAGAGGGAGAGTGAGAGAGTGGGAGAGAGAGACAGTGGACTCTGAGCAGCGGAGG
		AAA-GTGGTGTGAACGGGCATCTCCTGCCAGCAGTTAAAGCTCTGTCACCTCTGGGGATA
		GGCAGATGT-CCCGTGTGAGCATAAAGAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGGG-GCCCAGTAGGGCATCGGTGCTGTATGGTAGGATCGTCCACTAT
		CGCGTGAAACCCCGTCGCTACTAAAA-TACAAAAAATTAGCCGGGTGTGGAGGCCGGCCT
		CGGTAGGTCGAGCTACCGATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTT
		ACCTTC-GCGGTGGCCATTAGGCAGTGTGGGTCTAATAGCGGCAGG-ACCTGACTGAGTC
		CACACATCGCTGAAATGTGTCACGAGCCATGCGTGTGTGGCTGCAGCTGCCCTGAGG-AC
		AGCTCCTG-ATGC-ACGCGTCCCCGGGGACAACATCCAGTGTCCCTGCGTGCA-CCCAGA
		GAGCGCTACCCTCGCGGCACCTTCTCGCTCTCTAGACTTTAACACCTGACATTTGCCGAA
		ACAGCCAGTGGAACTGCTGCAACGAAGAATATCCAAGGGTGTGCCTTGGCTACAGGTCCA
		ATCTCACTTCAAGAGCTCTGACAACGGATACTTTACTCTTCAGTGGGATCTGCTAGTACC
		CGCTGGGCCGGGAATGCCAGC-CATACTCCTTCACCAGGGTAATCGTGATTATCCACTGT
		TGCTGATGGCCGCGACGCTGCGCGCACCCGAACAGTAACCGACG-GGCTGCCTGGCCTCC
		ACAACAATCTGGTGAAACAGAAGCATGGGGCAGGAGTTAGCATGGAACCACCAGGACGTC
		CAGCTGCCCCTCTTCAT-CGGGACCTCCGGATCCAGCATACGA-GA-GGCCTCCGTGGGA
		CTGCCAGTACTAGGCGATACAGCTCAGCCATACCTGCACCATTAACCCGCGCATGACCAG
		GTTTTGCGAGGAGGCGTGCG-GGTCCTGATCACTCCCCCACTGACAGGACCTCCAGGGGC
		AGCAACGCGATCCCTACGCCCTCAACCCGAGCATGAGCAGGACCTACGAGGAGGTGTGCT
		GGGTCCCTAAGTGCCTCCGCT-T-AGCTACGGGGAGGACCTGCGGATGGAATGTGATAGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCGC-CTCTTTCTTTCTCTCTCGT
		GGGAATTACACTGGCTATCAGGGCGCAGACCTCCTTACTCCCTCTTGGCTGGTGGATCCC
		CGGTTGGATGATTTCGGGAAACCACGTACGCTGCACGTGGAGGGGGTGGGGGGGGGGGCG
		GGGAAGCTGGGGGGGGGGGGGGAGGTGGGACATTCGAGGCCATCC-TCTTGCCGTCACCC
		CGCTGCCGTACCTGCCGGAC\n
		>Sequence_20 \n
		GAACTGACAGCTGTGTGGCAACGTTAACATCTT-GCTGAAGATCGTTTTTCAAGTGACAG
		GGTGACAGAGGGAGAGTGAGAGAGTGGGAGAGAGAGACAGTGGACTCTGAGCAGCGGAGG
		AAA-GTGGTGTGAACGGGCATCTCCTGCCAGCAGTTAAAGCTCTGTCACCTCTGGGGATA
		GGCAGATGT-CCCGTGTGAGCATAAAGAAAAAACAAAGAACAAAAAAAAGAAAAATAAAA
		AAACAAAAAAAACGGG-GCCCAGTAGGGCATCGGCGCTGTATGGTAGGATTGTCCACTAT
		CGCGTTAAACCCCGACGCTACTAAAA-TACAAAAAATTAGCCGGGTGTGGAGGCGGGCCT
		CGGTAGGTCGAGCTACCGATGGAGGCTGAGCCAGAGAGAATCGCGTGGCAGCCCAGTGTT
		ACCTTC-GCGGTGGCCATTAAGCAGTGTGGGTCTAATAGCGGCAGG-ACCTGACTGAGTC
		CACACATCGCTGAAATGTGTCACGAGCCATGCGTGTGTGGCTGCAGCTGCCCTGAGG-AC
		AGCTCCTG-ATGC-ACGCGTCCCCGGGGACAACATCCAGTGTCCCTGCGTGCA-CCGAGA
		GAGCGCTACCCTCGCGGCACCTTCTCGCTCTCTAGACTTTAACACCTGACATTTGCCGAA
		ACAGCCAGTGGAATTGCTGCAACGAAGAATATCCAAGGGTGTGCCTTGGCTACAGGTCCA
		ATCTCACTTCAAGAGCTCTGACAACGGATACTTTACTCTTCAGTGGGATCTGCTAGTACC
		CGCTGGGCCGGGAATGCCAGC-CATACTCCTTCACCAGGGTAATCGTGATTATCCACTGT
		TGCTGATGGCCGCGACGCTGCGCGCACCCGAACAGTACCCGACG-GGCTGCCTGGCCTCC
		ACAACAATCTGGTGAAACA-AAGCATGGGGCAGGAGTTAGCATGGAACCACCAGGACGTC
		CAGCTGCCCCTCTTCAA-CGGGACCTCCGGATCCAGCATACGA-GA-GGCCTCCGTGGGA
		CTGCCAGTACAAGGCGATACAGCTCAGCCATACCTGCACCATTAACCCGCGCATGACCAG
		GTTTTGCGAGGAGGCGTGCG-GGTCCTGATCACTCCCCCACTGACAGGACCTCCAGGGGC
		AGCAACGCGATCCCTACGCCCTCAACCCGAGCATGAGCAGGACCTACGAGGCGGTGTGCT
		GGGTCCCTAAGTGCCTCCGCT-T-AGCTACGGGGAGGACCTGCGGATGGAATGTGATAGC
		CGCAGGAGTCTCACTCTCTCCATGTCTCTCTCTCTCTCGCGCTGTTTCTTTCTCTCTCGT
		GGGAATTACACTGGCTATCAGGGCGCAGACCTCCCTACTCCCTCTTGGCTGGTGGATCCC
		CGGTTGGATGCTTTCGGGAAACCACGTACGCTGCACGTGGAGGGGGTGGGGGGGGGGGCG
		GGGAAGCTGGGGGGGGGGGGGGAGGTGGGACATTCCAGGCCATCC-TCTTGCCGTCACCC
		CGCTGCCGTACCTGCCGGAC";
	$sample_alignment=~s/\t//g;
	$sample_alignment=~s/\n//g;
	$sample_alignment=~s/ /\n/g;
	$sample_alignment=~s/>/\n>/g;
	$sample_alignment=~s/\n//;
	$input_paste->insert('end',"$sample_alignment");
	}